module.exports = function(grunt) {
  var pkg = grunt.file.readJSON('package.json');

  grunt.loadNpmTasks('grunt-contrib-uglify');
  grunt.loadNpmTasks('grunt-contrib-less');
  grunt.loadNpmTasks('grunt-contrib-imagemin');
  grunt.loadNpmTasks('grunt-contrib-copy');
  grunt.loadNpmTasks('grunt-contrib-watch');
  grunt.loadNpmTasks('grunt-contrib-coffee');

  // Change relative directory
  grunt.file.setBase('ckanext/dgu/theme/');

  // Project configuration.
  grunt.initConfig({
    pkg: pkg,
    uglify: {
      // options: { beautify: true, mangle: false, compress: false, }, //  <-- DEBUG MODE
      app: {
        files:  {
          'public/scripts/dgu-ckan-application.min.js' : [ 'src/scripts/dgu.js', 'src/scripts/dgu-autocomplete.js' ],
          'public/scripts/dgu-history.min.js'              : 'src/scripts/dgu-history.js',
          'public/scripts/dgu-package-form.min.js'         : 'src/scripts/dgu-package-form.js',
          'public/scripts/dgu-package.min.js'              : 'src/scripts/dgu-package.js',
          'public/scripts/dgu-publisher-forms.min.js'      : 'src/scripts/dgu-publisher-forms.js',
          'public/scripts/dgu-publisher-index.min.js'      : 'src/scripts/dgu-publisher-index.js',
          'public/scripts/dgu-publisher-read.min.js'       : 'src/scripts/dgu-publisher-read.js',
          'public/scripts/dgu-tracking.min.js'             : 'src/scripts/dgu-tracking.js',
          'public/scripts/dgu-image-upload.min.js'         : 'src/scripts/dgu-image-upload.js',
          'public/scripts/underscore.min.js'               : 'src/scripts/underscore.js',
          'public/scripts/rem.min.js'                      : 'src/scripts/rem.js',
          'public/scripts/app.min.js'                      : 'src/scripts/app.js',
          'public/scripts/vanilla-cookieconsent.min.js'    : ['src/sass/node_modules/vanilla-cookieconsent/src/cookieconsent.js', 'src/scripts/cookieconsent-opsi.js'],
        },
      },
      vendor: {
        files: {
          'public/scripts/vendor/jquery.tablesorter.min.js'   : 'src/scripts/vendor/jquery.tablesorter.js',
          'public/scripts/vendor/jquery.jstree.min.js'        : 'src/scripts/vendor/jquery.jstree.js',
          'public/scripts/vendor/jquery-ui-1.9.2.custom.datepicker.min.js'        : 'src/scripts/vendor/jquery-ui-1.9.2.custom.datepicker.js',
          'public/scripts/vendor/jquery-ui-datepicker-sl.min.js'        : 'src/scripts/vendor/jquery-ui-datepicker-sl.js',
          'public/scripts/vendor/jquery.fileupload.min.js'        : 'src/scripts/vendor/jquery.fileupload.js',
          'public/scripts/vendor/d3.v3.min.js'                : 'src/scripts/vendor/d3.v3.js',
          'public/scripts/vendor/d3.sankey.min.js'            : 'src/scripts/vendor/d3.sankey.js',
          'public/scripts/vendor/modal.min.js'            : 'src/scripts/vendor/modal.js',
        },
      },
      vendor_group: {
        src: [
          'src/scripts/vendor_group/jquery-ui-1.10.2.custom.js',
          'src/scripts/vendor_group/jquery.tagcloud.js',
          'src/scripts/vendor_group/spin.min.js',
          'src/scripts/vendor_group/jquery.chosen-1.4.2.js',
          'src/scripts/vendor_group/jquery.dotdotdot-1.5.9.js',
          'src/scripts/vendor_group/jquery.placeholder.js',
          'src/scripts/vendor_group/bootstrap-3.0.0.js',
          'src/scripts/vendor_group/jquery.tablesorter.js'
        ],
        dest: 'public/scripts/vendor_group.min.js'
      },
      recline: {
        src: [
          //'src/scripts/recline_pack/underscore-1.1.6.js',	//<- already loaded elsewhere on OPSI
          //'src/scripts/recline_pack/backbone-0.5.1.js',	//<- already loaded elsewhere on OPSI
          'src/scripts/recline_pack/backbone-1.3.3.js',
          'src/scripts/recline_pack/mustache.js',
          'src/scripts/recline_pack/bootstrap.js',
          'src/scripts/recline_pack/leaflet.js',
          'src/scripts/recline_pack/leaflet.markercluster.js',
          'src/scripts/recline_pack/jquery.event.drag-2.2.js',
          'src/scripts/recline_pack/jquery.event.drop-2.2.js',
          'src/scripts/recline_pack/slick.core.js',
          'src/scripts/recline_pack/slick.formatters.js',
          'src/scripts/recline_pack/slick.editors.js',
          'src/scripts/recline_pack/slick.grid.js',
          'src/scripts/recline_pack/plugins/slick.rowselectionmodel.js',
          'src/scripts/recline_pack/plugins/slick.rowmovemanager.js',
          'src/scripts/recline_pack/recline.js',
          'src/scripts/recline_pack/dgu-recline-integration.js',
        ],
        dest: 'public/scripts/dgu-recline-pack.min.js',
      },

    },
    less: {
      options: {
        yuicompress: true
      },
      build: {
        src: 'src/css/dgu-ckan.less',
        dest: 'public/css/dgu-ckan.min.css'
      },
      etl1: {
        src: 'src/css/social-investment-and-foundations.less',
        dest: 'public/css/social-investment-and-foundations.min.css',
      },
      etl2: {
        src: 'src/css/investment-readiness-programme.less',
        dest: 'public/css/investment-readiness-programme.min.css',
      },
      datepicker: {
        src: 'src/css/jquery-ui-1.9.2.custom.datepicker.css',
        dest: 'public/css/jquery-ui-1.9.2.custom.datepicker.min.css',
      },
      recline: {
        src: [ 
          'src/css/recline_pack/leaflet.css',
          'src/css/recline_pack/MarkerCluster.css',
          'src/css/recline_pack/MarkerCluster.Default.css',
          'src/css/recline_pack/slick.grid.css',
          'src/css/recline_pack/bootstrap.css',
          'src/css/recline_pack/recline.css',
          'src/css/recline_pack/recline-data-explorer.min.css',
          'src/css/recline_pack/recline-grid.css',
          'src/css/recline_pack/dgu-recline-integration.css'
        ],
        dest: 'public/css/dgu-recline-pack.min.css'
      },
      cookie: {
        src: [
          'src/sass/node_modules/vanilla-cookieconsent/src/cookieconsent.css',
          'src/css/cookieconsent-opsi.css'
        ],
        dest: 'public/css/vanilla-cookieconsent.css',
      },
      bootstrapModal: {
        src: 'src/css/bootstrap-modal.css',
        dest: 'public/css/bootstrap-modal.min.css',
      }
    },
    watch: {
      json: { 
        files: 'src/scripts/json/**/*.json',
        tasks: 'copy:json'
      },
      styles: {
        files: 'src/css/**/*',
        tasks: 'styles'
      },
      scripts: {
        files: 'src/scripts/dgu*.js',
        tasks: 'uglify:app'
      },
      coffee: {
        files: 'src/scripts/**/*.coffee',
        tasks: 'coffee'
      },
    },
    imagemin: {
      build: {
        options: { 
          optimizationLevel: 3
        },
        files: [
          {
            expand: true,
            src: '**/*.{jpg,png}',
            cwd: 'src/images/',
            dest: 'public/images/'
          }
        ]
      },
    },
    copy: {
      css: {
        expand: true,
        cwd: 'src/css/',
        src: [
          'app.css',
        ],
        dest: 'public/css/'
      },
      images: {
        expand: true,
        cwd: 'src/images/',
        src: '**/*.gif',
        dest: 'public/images/',
      },
      img: {
        expand: true,
        cwd: 'src/img/',
        src: '**/*.{png,gif,ico,svg}',
        dest: 'public/img/',
      },
      json: {
        expand: true,
        cwd: 'src/scripts/json/',
        src: '**/*.json',
        dest: 'public/scripts/json/',
      },
      fonts: {
        expand: true,
        cwd: 'src/fonts/opsi/',
        src: '**/*',
        dest: 'public/fonts/opsi/'
      },
      fonts_roboto: {
        expand: true,
        cwd: 'src/fonts/Roboto/',
        src: '**/*',
        dest: 'public/fonts/Roboto/'
      },
      fonts_foundation: {
        expand: true,
        cwd: 'src/css/',
        src: '**/*.{eot,svg,ttf,woff}',
        dest: 'public/css/'
      }
    },
    coffee: {
      etl1: {
        src: [
          'src/scripts/viz_pack/viz_lib/*.coffee',
          'src/scripts/viz_pack/social-investment-and-foundations.coffee',
        ],
        dest: 'public/scripts/social-investment-and-foundations.min.js'
      },
      etl2: {
        src: [
          'src/scripts/viz_pack/viz_lib/*.coffee',
          'src/scripts/viz_pack/investment-readiness-programme.coffee',
        ],
        dest: 'public/scripts/investment-readiness-programme.min.js'
      }
    },
    timestamp: {
      build: {
        dest: 'timestamp.py'
      }
    }
  });

  grunt.registerMultiTask('timestamp', 'Write timestamp to a file', function(myName, myTargets) {
    grunt.file.write(this.files[0].dest, 'asset_build_timestamp='+Date.now());
  });
  // Default task(s).
  grunt.registerTask('styles', ['less','timestamp']);
  grunt.registerTask('scripts', ['uglify:app','timestamp','coffee']);
  grunt.registerTask('images', ['imagemin','copy:images','timestamp']);
  grunt.registerTask('default', ['uglify','coffee','less','imagemin','copy','timestamp']);

};
