# -*- coding: utf-8 -*-

import logging
import sys
import os
import re
from datetime import datetime
from ckan.lib.cli import CkanCommand

class CustomTags(CkanCommand):

    """
    """
    summary = __doc__.split('\n')[0]
    usage = __doc__
    max_args = 1
    min_args = 0

    def __init__(self, name):
        super(CkanCommand, self).__init__(name)

    def command(self):
        self._load_config()
        log = logging.getLogger(__name__)
        import ckan.plugins.toolkit as tk
        import ckan.model as model
        
        reset_tags = False
        vocab_default_action = 'vocabulary_create'
        if len(self.args) > 0:
            cmd = self.args[0]
            if cmd == 'reset':
                reset_tags = True
                vocab_default_action = 'vocabulary_update'
        
        podrocja_tags = [
            {'name': u'Energetika'},
            {'name': u'Finance in davki'},
            {'name': u'Gospodarstvo'},
            {'name': u'Izobraževanje. kultura in šport'},
            {'name': u'Kmetijstvo. ribištvo. gozdarstvo in prehrana'},
            {'name': u'Mednarodne zadeve'},
            {'name': u'Okolje in prostor'},
            {'name': u'Pravosodje. pravni sistem in javna varnost'},
            {'name': u'Prebivalstvo in družba'},
            {'name': u'Promet in infrastruktura'},
            {'name': u'Sociala in zaposlovanje'},
            {'name': u'Javni sektor'},
            {'name': u'Zdravje'},
            {'name': u'Znanost in tehnologija'}
        ]
        existing = model.Vocabulary.by_name('podrocja')
        if not existing:
            result1 = tk.get_action('vocabulary_create')(
                data_dict={'name': 'podrocja', 'tags': podrocja_tags})
            print result1
        elif reset_tags:
            result1 = tk.get_action('vocabulary_update')(
                data_dict={'id': existing.id, 'tags': podrocja_tags})
            print result1
            
        dostopnost_tags=[
            {'name': u'1. Podatki v celoti oz. v pretežni meri niso javno dostopni'},
            {'name': u'2. Podatki so javno dostopni in na voljo za dostop in ponovno uporabo'},
            {'name': u'3. Na voljo je spletni vpogled v podatke'},
            {'name': u'4. Podatki so objavljeni kot odprti podatki'}
        ]
        existing = model.Vocabulary.by_name(u'Dostopnost podatkov')
        if not existing:
            result2 = tk.get_action('vocabulary_create')(
                data_dict={'name': u'Dostopnost podatkov', 'tags': dostopnost_tags})
            print result2
        elif reset_tags:
            result2 = tk.get_action('vocabulary_update')(
                data_dict={'id': existing.id, 'tags': dostopnost_tags})
            print result2
        
        licence_tags = [
            {'name': u'Creative Commons Attribution'},
            {'name': u'Creative Commons Attribution-ShareAlike'},
            {'name': u'Creative Commons Attribution-NoDerivs'},
            {'name': u'Creative Commons Attribution-NonCommercial'},
            {'name': u'Creative Commons Attribution-NonCommercial-ShareAlike'},
            {'name': u'Creative Commons Attribution-NonCommercial-NoDerivs'}
        ]
        existing = model.Vocabulary.by_name('licence')
        if not existing:
            result3 = tk.get_action('vocabulary_create')(
                data_dict={'name': 'licence', 'tags': licence_tags})
            print result3
        elif reset_tags:
            result3 = tk.get_action('vocabulary_update')(
                data_dict={'id': existing.id, 'tags': licence_tags})
            print result3
        
        jeziki_tags = [
            {'name': u'1. Slovenščina'},
            {'name': u'2. Angleščina'},
            {'name': u'3. Hrvaščina'},
            {'name': u'4. Italijanščina'},
            {'name': u'5. Madžarščina'},
            {'name': u'6. Nemščina'}
        ]
        existing = model.Vocabulary.by_name('jeziki')
        if not existing:
            result4 = tk.get_action('vocabulary_create')(
                data_dict={'name': 'jeziki', 'tags': jeziki_tags})
            print result4
        elif reset_tags:
            result4 = tk.get_action('vocabulary_update')(
                data_dict={'id': existing.id, 'tags': jeziki_tags})
            print result4
        
        pogostost_osvezevanja_tags = [
            {'name': u'01. stalno'},
            {'name': u'02. dnevno'},
            {'name': u'03. tedensko'},
            {'name': u'04. dvotedensko'},
            {'name': u'05. mesečno'},
            {'name': u'06. četrtletno'},
            {'name': u'07. polletno'},
            {'name': u'08. letno'},
            {'name': u'09. po potrebi'},
            {'name': u'10. neredno'},
            {'name': u'11. ni načrtovano'},
        ]
        existing = model.Vocabulary.by_name('pogostost_osvezevanja')
        if not existing:
            result5 = tk.get_action('vocabulary_create')(
                data_dict={'name': 'pogostost_osvezevanja', 'tags': pogostost_osvezevanja_tags})
            print result5
        elif reset_tags:
            result5 = tk.get_action('vocabulary_update')(
                data_dict={'id': existing.id, 'tags': pogostost_osvezevanja_tags})
            print result5