# -*- coding: utf-8 -*-
import logging

from ckanext.dgu.lib.helpers import get_executive_editors
from ckanext.dgu.lib.mailer_opsi import mail_recipient
from ckan.lib.base import _, c, h
from pylons import config

log = logging.getLogger(__name__)
def _generate_admin_recipient(user):
    if not config.get('email_to'):
        log.error('Obvestilo o osnutku uporabnika "%s" ni bilo poslano, ker v '
                  'nastavitvah CKAN-a ni nastavljen naslov dgu.admin.email.',
                  str(c.user))
        h.flash_error(_("Napaka v sistemski konfiguraciji"))
        return None
    
    return [(config.get('error_email_from', 'OPSI Administrator'), config['email_to'], 0)]

def send_email_to_executive_editors(email_msg, email_subject, is_web=True):
    from ckan.logic.action import error_summary

    recipients = get_executive_editors()
    if not recipients:
        recipients =  _generate_admin_recipient(c.user)
        if not recipients:
            return False

    try:
        sent_emails = [] #prevent duplicate sending to same email if multiple users happen to have same email
        for (name,email,id) in recipients:
            if email not in sent_emails:
                mail_recipient(name,
                               email,
                               subject=email_subject,
                               body=email_msg)
                sent_emails.append(email)
        log.info('Sent email with subject ' + email_subject + ' to editors: ' + str(recipients))
        return True
    except Exception, e:
        if is_web:
            contact_url = config.get('ckan.site_url', 'https://podatki.gov.si')+'/kontakt'
            h.flash_error(u'Pri pošiljanju obvestil o vašem zahtevku je prišlo do napake. Prosimo, da nas o tem obvestite s <a href="' + contact_url + u'">kontaktnim obrazcem</a> na naši strani.', allow_html=True)
        log.error('Failed sending email to executive editors because of mail configuration error.', exc_info=True)
