from pylons import config

import ckan.lib.mailer as mailer

def empty_msg_niceties(recipient_name, body, sender_name, sender_url):
    return body + u"\r\n\r\n--\r\n%s (%s)" % (sender_name, sender_url)
mailer.add_msg_niceties = empty_msg_niceties

def register_translator():
    # Register a translator in this thread so that
    # the _() functions in logic layer can work
    from paste.registry import Registry
    from pylons import translator
    from ckan.lib.cli import MockTranslator
    global registry
    registry = Registry()
    registry.prepare()
    global translator_obj
    translator_obj = MockTranslator()
    registry.register(translator, translator_obj)
    
def mail_recipient_wrapper(recipient_name, recipient_email, subject,
                   body, headers={}):
    register_translator();
    site_title = str(config.get('ckan.site_title')).encode('utf8')
    site_url = str(config.get('ckan.site_url')).encode('utf8')
    mailer._mail_recipient(recipient_name, recipient_email, 
                           site_title, site_url, subject, body, headers=headers)

def mail_recipient(recipient_name, recipient_email, subject,
                   body, headers={}):
    from threading import Thread
    #send mails in separate threads to avoid waiting for rate limiters
    Thread(target=mail_recipient_wrapper, args=[recipient_name, recipient_email,
                           subject, body], kwargs={'headers': headers}).start()
