/*
  npm install --save-dev gulp-minify
*/

var gulp = require('gulp');
var $    = require('gulp-load-plugins')();
const sass = require('gulp-sass');

// SCSS

var sassPaths = [
  'bower_components/foundation-sites/scss',
  'bower_components/foundation-icon-fonts',
  'bower_components/motion-ui/src'
];

gulp.task('sass', function() {
  return gulp.src(['scss/app.scss', './js/cookieconsent/src/*.css'])
    .pipe(sass({
      includePaths: sassPaths,
      outputStyle: 'compressed' // if css compressed **file size**
    })
      .on('error', sass.logError))
    .pipe($.autoprefixer({
      browsers: ['last 2 versions', 'ie >= 9']
    }))
    .pipe(gulp.dest('../css'));
});

// JS

var concat = require('gulp-concat');
var minify = require('gulp-minify');

gulp.task('scripts', function(cb) {
  gulp.src(['./bower_components/jquery.cookie/jquery.cookie.js',
    './bower_components/foundation-sites/js/foundation/foundation.js', './bower_components/foundation-sites/js/foundation/foundation.topbar.js',
    './bower_components/foundation-sites/js/foundation/foundation.equalizer.js', './bower_components/foundation-sites/js/foundation/foundation.offcanvas.js',
    './bower_components/foundation-sites/js/foundation/foundation.accordion.js', './bower_components/foundation-sites/js/foundation/foundation.clearing.js',
    './bower_components/foundation-sites/js/foundation/foundation.tab.js', './bower_components/foundation-sites/js/foundation/foundation.reveal.js',
    './bower_components/confirm-with-reveal/build/confirm_with_reveal.min.js', './bower_components/querystring/querystring.js',
    './js/app.js'], {"allowEmpty": true}
    )
    .pipe(concat('app.js'))
    .pipe(minify({
        ext:{
            src:'.js',
            min:'.min.js'
        },
        //exclude: ['tasks'],
        ignoreFiles: ['.combo.js', '.min.js']
    }))
    .pipe(gulp.dest('../scripts'));
    cb();
});

// TASKS

gulp.task('default', gulp.series(['sass', 'scripts']), function(cb) {
  gulp.watch(['scss/**/*.scss'], ['sass']);
  gulp.watch(['js/*.js'], ['scripts']);
  gulp.watch(['../templates/**/*.twig']);

});
