// Constants (const CONSTANT = xyz; is not supported by IE8, IE9, IE10)

var SMALL_BREAKPOINT = 640;
var MEDIUM_BREAKPOINT = 1024;
var LARGE_BREAKPOINT = 1440;
var XLARGE_BREAKPOINT = 1920;

// CKAN - Filter accordion
function ckan_filterAccordionInit() {
	var width = jQuery(window).width();
	if (width < MEDIUM_BREAKPOINT) {
		jQuery('#left-accordion').addClass('mobile').foundation('accordion', 'close')
	} else {
		jQuery('#left-accordion').removeClass('mobile').foundation('accordion', 'open')
	}
}

function scrollTo(elId) {
    jQuery('html, body').animate({ scrollTop: jQuery(elId).offset().top - jQuery('div.top-bar').height() }, 500);
}

jQuery(document).ready(function(){

	ckan_filterAccordionInit(); // Close filter accordion for mobile view

	// Event listeners -------------------------------

	// Header top - Mobile menu
	jQuery('header div.top a.burger').click(function(){
		if (jQuery(this).hasClass('active')) {
			jQuery(this).removeClass('active');
			jQuery('#menu-header-top').slideUp();
		} else {
			jQuery(this).addClass('active');
			jQuery('#menu-header-top').slideDown();
		} 
	});

	// Header middle - Mobile menu 
	jQuery('header div.middle a.burger').click(function(){
		if (jQuery(this).hasClass('active')) {
			jQuery(this).removeClass('active');
			jQuery('#left-off-canvas-toggle').trigger('click');
		} else {
			jQuery(this).addClass('active');
			jQuery('#left-off-canvas-toggle').trigger('click');
		} 
	});

	// List of sectors - equlize height
	var sectorLists = jQuery('.areas_wrapper ul.sectors').children('li');
	if (sectorLists.length) {
		var t = 0;	// The height of the highest element (after the function runs)
		var h = 0;	// The height of the a chiled of highest element
		var t_elem;	// The highest element (after the function runs)
		sectorLists.each(function () {
		    $this = jQuery(this);
		    if ( $this.height() > t ) {
		        t_elem=this;
		        t = $this.height();
		        h = $this.children('a').height();
		    }
		});
		jQuery('.areas_wrapper ul.sectors li a').css('minHeight',h + 'px');
	}

	// Drop down menu
	/*
	jQuery('ul.menu li.expanded > a').click(function(e){
		e.preventDefault();
		jQuery(this).siblings('ul.menu').toggle();
	}); 
	*/
	var submenuTimer;
	jQuery("header ul.menu li.expanded").mouseenter(function(){
		clearTimeout(submenuTimer);
		var menuElement = jQuery(this).children('ul.menu');
		jQuery('ul.menu li ul.menu').not(menuElement).hide();
		menuElement.show();
	}).mouseleave(function(){
		var element = jQuery(this);
		submenuTimer = setTimeout(function(){ element.children('ul.menu').hide(); }, 500);
	});
	jQuery("header ul.menu li.expanded ul.menu").mouseenter(function(){
		clearTimeout(submenuTimer);
	}).mouseleave(function(){
		var element = jQuery(this);
		submenuTimer = setTimeout(function(){ element.hide(); }, 500);
	});

	// Accessibility
	jQuery('#accessibility').click(function(){
		jQuery(this).toggleClass('active');
		jQuery('div.accessibility').stop(true, true).slideToggle();
	});

	jQuery('a.view_theme').click(function(){
		jQuery.cookie("view_theme", jQuery(this).attr('view_theme'), { expires: 10, path: '/', domain: '', secure: false });
		location.reload();
	});

	jQuery('a.view_mode').click(function(){
		var mode = jQuery(this).attr('view_mode');
		var remove_cookie = !jQuery(this).hasClass(mode);
		if (remove_cookie) {
			//jQuery.cookie(mode, null, { path: '/' });
			jQuery.removeCookie(mode, { path: '/' });
		} else {
			jQuery.cookie(mode, jQuery(this).attr('view_mode'), { expires: 10, path: '/', domain: '', secure: false });
		}
		location.reload();
	});

	// CKAN filters - accordion
	jQuery('#left-accordion').click(function(e){
		if (e.target !== this) return; // If the e.target is the same element as this, you've not clicked on a descendant.
		if (jQuery(window).width() > MEDIUM_BREAKPOINT) {
			e.preventDefault();
		}
	});  
	jQuery(window).resize(function(){
		ckan_filterAccordionInit();
		jQuery(document).foundation('equalizer', 'reflow'); // (Re)Set equal heights
	});

	// CKAN search filter
	jQuery('#search-sort-by select.form-control').change(function(){
		var q = querystring.parse(location.search); // parse the query string into an object
		q.sort = jQuery(this).val().replace(" ", "+");
		window.location.search = querystring.stringify(q);
	});

	// Display email links
	jQuery("span.email a").each(function( index ) {
		var email = JSON.parse(CryptoJS.AES.decrypt(jQuery(this).attr('encrypred-data'), 'opsi', {format: CryptoJSAesJson}).toString(CryptoJS.enc.Utf8));
	 	jQuery(this).attr('href', 'mailto:' + email).text(email);
	});

	// Add offset to the first sector on the list
	sectorListViewOffset();
	jQuery(window).resize(function() { sectorListViewOffset(); });

});

jQuery(window).bind("load", function () {
	jQuery('body.admin-menu').attr('style', 'margin-top: ' + jQuery('#admin-menu').height() + 'px !important;'); //.style("margin-top", jQuery('#admin-menu').height() + 'px', 'important');
});


function sectorListViewOffset() {
	if (jQuery("ul.sectors li").length) {
		var first_child = jQuery("ul.sectors li").first();
		if (jQuery(window).width() > 625) {
			var offset = Math.floor(first_child.width() / 2) + 16;
			first_child.css('margin-left',offset + 'px');
		} else {
			first_child.css('margin-left','0');
		}
	}

	jQuery("ul.sectors li").css('height', null);
	var height, max_height = 0;
	jQuery("ul.sectors li").each(function(index) {
		height = jQuery(this).height();
		if (height > max_height) max_height = height;
	});
	jQuery("ul.sectors li").height(max_height);
}

/*###############################
* CKAN
* ################################ */

jQuery(document).ready(function(){

	// ### DATASET FORM - ADD OR EDIT

	jQuery("ul[data-tab] li a").click(function(e) {
		if (jQuery(this).hasClass('disabled')) {
			e.preventDefault();
		}
	});

	// Modal window - Form
	jQuery('.form-reveal-close').click(function(){
		jQuery(this).parents('.reveal-modal').foundation('reveal', 'close');
	});
	jQuery('.form-reveal-save').click(function(){
		var modal_window = jQuery(this).parents('.reveal-modal');
		var inputs = modal_window.find("input");
            jQuery.each(inputs, function(i, input) {
                input = jQuery(input);
                var targetLabel = input.attr("data-label");
                var targetInput = input.attr("data-input");
                if (targetLabel) {
                    jQuery(targetLabel).text(input.val());
                }
                if (targetInput) {
                    jQuery(targetInput).val(input.val());
                }
            });
		modal_window.foundation('reveal', 'close');
	});

	// Tabs and form buttons
	jQuery('#form-tabs').on('toggled', function (event, tab) {
		jQuery(document).foundation('equalizer', 'reflow');
		(tab.is(':first-child')) ? jQuery('#back-button').hide() : jQuery('#back-button').show();
        (tab.is(':last-child')) ? jQuery('#next-button').hide() : jQuery('#next-button').show();
        // scrollTo('.titlebar');
        scrollTo(tab[0]);
    	jQuery(document).foundation('equalizer', 'reflow'); // (Re)Set equal heights
	});
	jQuery('#next-button').click(function() {
		if (!jQuery(this).hasClass('disabled')) {
			var tab = jQuery('.tabs li.active').next();
			if (tab.length == 1) {
				tab.children('a').click();
			}
		}
	});
	jQuery('#back-button').click(function() {
		if (!jQuery(this).hasClass('disabled')) {
			var tab = jQuery('.tabs li.active').prev();
			if (tab.length == 1) {
				tab.children('a').click();
			}
		}
	});

	// Organisation selector - close drop-down on selection ( /publisher/apply )
	/*
	jQuery('ul.chosen-results li').click(function(){
		console.log('Test');
		jQuery(this).parent().hide();
	});
	*/

});