var _paq = _paq || [];
_paq.push(['requireConsent']); //required for cookie consent
_paq.push(['trackPageView']);
_paq.push(['enableLinkTracking']);

document.addEventListener('DOMContentLoaded', function() {
    // obtain cookieconsent plugin
    var cc = initCookieConsent();
    cc.run({
	autorun : true, 
	delay : 0,
	current_lang : 'sl',
	auto_language : false,
	autoclear_cookies : true,
	cookie_expiration : 365,
	theme_css: '/css/vanilla-cookieconsent.css',
	use_rfc_cookie: true,
	force_consent: false,

	onAccept: function(cookie){
		if(cc.allowedCategory('translate')){
			cc.loadScript('https://translate.google.com/translate_a/element.js?cb=googleTranslateElementInit', function(){});
		}
		
		if(cc.allowedCategory('analytics')){
			_paq.push(['setConsentGiven']);
		}
		
		//initialization of _paq variable is still in html.tpl.php head
		//it would probably be possible to just avoid requesting piwik.js altogether when the Matomo cookies 
		//are not allowed, but this has the handy feature of deleting cookies when user rejects them later on.
		(function() { 
		  var u="/analitika/"; 
		  _paq.push(['setTrackerUrl', u+'piwik.php']); 
		  _paq.push(['setSiteId', 4]); 
		  var d=document, g=d.createElement('script'), s=d.getElementsByTagName('script')[0]; 
		  g.type='text/javascript'; g.async=true; g.defer=true; g.src=u+'piwik.js'; s.parentNode.insertBefore(g,s); 
		})(); 
	},

	onChange: function(cookie){
		if(cc.allowedCategory('translate')){
			cc.loadScript('https://translate.google.com/translate_a/element.js?cb=googleTranslateElementInit', function(){});
		}
		
		if(cc.allowedCategory('analytics')){
			_paq.push(['setConsentGiven']);
		}
	},

	languages : {
		'en' : {	
			consent_modal : {
				title :  "Uporabljamo piškotke",
				description :  'Portal OPSI uporablja nekaj nujnih piškotkov za prijavo in pomnjenje uporabniških nastavitev. Ob vaši odobritvi naloži še analitične piškotke za spremljanje obiska ter piškotke storitve Google Translate za prevajanje v druge jezike. <a class="cc-link" data-cc="c-settings" aria-haspopup="dialog">Podrobne nastavitve</a>',
				primary_btn: {
					text: 'Sprejmem vse',
					role: 'accept_all'				//'accept_selected' or 'accept_all'
				},
				secondary_btn: {
					text : 'Le nujni',
					role : 'accept_necessary'				//'settings' or 'accept_necessary'
				}
			},
			settings_modal : {
				title : '<div>Nastavitve piškotkov</div><div aria-hidden="true" style="font-size: .8em; font-weight: 200; color: #687278; margin-top: 5px;"></div>',
				save_settings_btn : "Shrani nastavitve",
				accept_all_btn : "Sprejmi vse",
				close_btn_label: "Zapri",
				cookie_table_headers : [
					{col1: "Ime" }, 
					{col2: "Domena" }, 
					{col3: "Rok trajanja" }, 
					{col4: "Opis" }
				],
				blocks : [
					{
						title : "Uporaba piškotkov",
						description: 'Piškotke uporabljamo za zagotovitev osnovnih funkcionalnosti portala in za izboljšavo uporabniške izkušnje. Uporabo opcijskih kategorij in povezanih piškotkov lahko vedno ponastavite. Več lahko preberete v naši <a href="https://podatki.gov.si/piskotki" class="cc-link">Politiki zasebnosti</a>.'
					},{
						title : "Nujni",
						description: 'Ti piškotki so nujni za pravilno uporabo portala in se naložijo po potrebi glede na uporabljene funkcije (prijava, dostopnost, ...).',
						toggle : {
							value : 'necessary',
							enabled : true,
							readonly: true							//cookie categories with readonly=true are all treated as "necessary cookies"
						},
						cookie_table: [
							{
								col1: 'has_js',
								col2: 'podatki.gov.si',
								col3: 'Čas seje*',
								col4: 'Shrani, če ima uporabnikov brskalnik omogočen JavaScript. To informacijo uporablja tehnologija Drupal, ki se uporablja za vodenje vsebin, zato da prilagodi prikaz uporabnikovemu brskalniku'
							},
							{
								col1: 'ckan',
								col2: 'podatki.gov.si',
								col3: 'Čas seje*',
								col4: 'Stanje pregledovanja podatkovnih zbirk na portalu – shranjevanje sprememb v primeru, da uporabnik ureja vsebino ali objavlja komentarje'
							},
							{
								col1: 'SESS...',
								col2: 'podatki.gov.si',
								col3: 'Čas seje*',
								col4: 'Omogoča, da se spletišče zaveda, da je uporabnik prijavljen.'
							},
							{
								col1: 'auth_tkt',
								col2: 'podatki.gov.si',
								col3: 'Čas seje*',
								col4: 'Omogoča, da se spletišče zaveda, da je uporabnik prijavljen. Ustvari se na podlagi piškotka SESS... za namen podstrani, ki prikazujejo in urejajo podatkovne zbirke. V primeru, da se SESS... izbriše, se razveljavi tudi ta.'
							},
							{
								col1: 'view_theme',
								col2: 'podatki.gov.si',
								col3: '10 dni od časa kreiranja piškotka',
								col4: 'Uporabnikove nastavitve dostopnosti, piškotek se naloži le v primeru uporabe te funkcionalnosti'
							},
							{
								col1: 'ctools-collapsible-state',
								col2: 'podatki.gov.si',
								col3: 'Čas seje*',
								col4: 'Shranjuje, ali ima uporabnik odprte nekatere razširljive menuje na portalu.'
							},
							{
								col1: 'Drupal.toolbar.colapsed in ostali "Drupal..."',
								col2: 'podatki.gov.si',
								col3: 'Dolgoročno (pol leta, leto ali več)',
								col4: 'Shranjevanje trenutnega položaja in stanja menujev.'
							},
							{
								col1: 'package_likes',
								col2: 'podatki.gov.si',
								col3: 'Dolgoročno (pol leta, leto ali več)',
								col4: 'Omogoča omejitev spletišča, da uporabnik posamezno zbirko lahko všečka le enkrat'
							},
							{
								col1: 'cc_cookie',
								col2: 'podatki.gov.si',
								col3: '1 leto',
								col4: 'Shranjuje nastavitve uporabe piškotkov'
							}
						]
					},{
						title : "Analitični",
						description: 'Ti piškotki zbirajo informacije o obiskanih straneh z orodjem Matomo Analytics. Uporabljamo jih za spremljanje obiska in uporabe portala.',
						toggle : {
							value : 'analytics',	//there are no default categories => you specify them
							enabled : false,
							readonly: false
						},
						cookie_table: [
							{
								col1: '_pk_..., mtm_..., matomo_...',
								col2: 'podatki.gov.si',
								col3: 'Različna (ID strani se hrani eno leto, trenutni obisk le za čas seje)',
								col4: 'Statistično sledenje sistema Matomo Analytics'
							}
						]
					},{
						title : "Prevajanje Google",
						description: 'Ti piškotki vam omogočijo pasico za prevajanje v druge jezike, ki jo nudi orodje Google Translate',
						toggle : {
							value : 'translate',
							enabled : false,
							readonly: false
						},
						cookie_table: [
							{
								col1: 'googtrans',
								col2: 'podatki.gov.si',
								col3: 'Čas seje*',
								col4: 'Shrani nastavitev jezika v pasici Google Translate po njeni uporabi'
							},
							{
								col1: 'CONSENT',
								col2: '.google.com',
								col3: 'Dolgoročno (pol leta, leto ali več)',
								col4: 'Hrani odobritev uporabnika, da se strinja z beleženjem Googlovih storitev (potrdite ga na drugih spletnih straneh, npr. ob uporabi iskalnika Google)'
							}
						]
					},{
						title : "Več informacij",
						description: '* Čas seje je pogojen tudi z nastavitvami brskalnika: če je ta nastavljen, da si ob zaprtju okna zapomni seznam zavihkov in odprtih oken, se s tem shranijo tudi sejni piškotki.<br>Za več informacij o politiki zasebnosti ali uporabi piškotkov prosimo, da nas <a class="cc-link" href="https://podatki.gov.si/kontakt">kontaktirate</a>.',
					}
				]
			}
		}
	}
    });
}, false);

