jQuery(function($) {
  assert(window.form_errors, 'window.form_errors not set');

  var isDatasetNew = jQuery('div.icon.new').length > 0; //we check action which is written as class in icon div
  var errorFieldsets = [];

  for (field_id in window.form_errors) {

    var errors = window.form_errors[field_id];
    if( ! errors.length) { return; }

    // errors could be nested, in which case it's a list of objects.
    // We need to find the first reference to an error in the list of
    // objects, and pull out a field_id from that.
    if( typeof(errors[0]) === "object" ){
      found = false;
      for(var i=0; i<errors.length && !found; i++){
        for(key in errors[i]){
          field_id = field_id + '__' + i + '__' + key;
          found = true;
          break;
        }
      }
    }
    var field = jQuery("#" + field_id);
      if (field !== undefined && field.length > 0) {
        var fieldset_id = field.parents("div.tab-content").last().attr("id");
        errorFieldsets.push(fieldset_id);
        fieldset_id = fieldset_id.replace(/-fields?$/, "");
        jQuery("#" + fieldset_id).addClass("fieldset_button_error");
     }
  }

  if (errorFieldsets.length>0) {
    window.location.hash = 'tab-'+errorFieldsets[0];
  }

  /* URL auto-completion */
  if (isDatasetNew) {
    // Set up magic URL slug editor
    var urlEditor = new CKAN.Dgu.UrlEditor({ 'slugType': 'package'});
    jQuery("#title").focus();
  }

  /* Handle prev/next buttons */
  jQuery('.package_create_form a[data-toggle="tab"]').on('click', function(e) {
    var target = jQuery(e.delegateTarget);
    if (target.hasClass('disabled')) {
      e.preventDefault();
      return false;
    }
  });
  jQuery('.package_create_form a[data-toggle="tab"]').on('click', function(e) {
    var target_a = jQuery(e.target);
    var target_li = target_a.parent();
    var hasPrevious = target_li.prev().length > 0;
    var hasNext = target_li.next().length > 0;

    // Handle the back/next buttons
    if (hasPrevious) {
      jQuery('#back-button').show();
    } else {
      jQuery('#back-button').hide();
    }
    if (hasNext) {
      jQuery('#next-button').show();
    } else {
      jQuery('#next-button').hide();
    }
  });

  /* Show the correct resource fieldset */
  CKAN.Dgu.showHideResourceFieldsets();
  /* Add new rows */
  CKAN.Dgu.copyTableRowOnClick(jQuery('#additional_resources-add'), jQuery('#additional_resources-table'));
  CKAN.Dgu.copyTableRowOnClick(jQuery('#timeseries_resources-add'), jQuery('#timeseries_resources-table'), true);
  CKAN.Dgu.copyTableRowOnClick(jQuery('#individual_resources-add'), jQuery('#individual_resources-table'), true);
  
  /* init final rows */
  CKAN.Dgu.initForUpload(jQuery(".timeseries_resource").last());
  CKAN.Dgu.initForUpload(jQuery(".individual_resource").last());

  function add_extra_select(list_selector) {
    return function(e){
      console.log('add_extra_select 3');
      var list = jQuery(list_selector);

      var new_select = list.find('select').first().clone();

      new_select.removeAttr('value');
      new_select.removeAttr('style');
      new_select.removeAttr('id');
      new_select.removeClass('chzn-done');

      var new_list_item = jQuery('<li></li>').append(new_select);

      list.append(new_list_item);

      new_select.chosen({allow_single_deselect: true});

      return false;
    }
  }

  // Correctly handle disabled nav buttons
  jQuery('a.disabled').click(function(e) {
    e.preventDefault();
  });

  jQuery('#back-button').click(function(e) {
      e.preventDefault();
      var activeTab = jQuery('div#form-tabs li.active');
      activeTab.prev().children('a').click();
  });
  jQuery('#next-button').click(function(e) {
      e.preventDefault();
      var nextLink = jQuery('div#form-tabs li.active').next().children('a');
      if (nextLink.hasClass('disabled')) {
        nextLink.removeAttr('disabled');
        // Allow it to be clicked
        nextLink.removeClass('disabled');
      }
      // Click it
      nextLink.click();
  });


  /* Tag auto-completion */
  CKAN.Dgu.setupTagAutocomplete(jQuery('input.autocomplete-tag'));
  CKAN.Dgu.setupPackageAutocomplete(jQuery('input.autocomplete-package'));
  CKAN.Dgu.setupUserAutocomplete(jQuery('input.autocomplete-creator'));

  /* Auto-fill contact and FOI information based upon selected publisher */
  var publisherInfoFields = [
    "contact-name",
    "contact-email",
    "contact-phone"
  ];
  
  function set_form_triplet(field, value){
      jQuery('#' + field).val(value);
      jQuery('#' + field + '-dialog').val(value);
      jQuery('#' + field + '-label').text(value);
  }
  //publisher and dataset edit form autofill
  jQuery('#groups__0__name,#owner_org').each(function(){ 
    jQuery(this).change(function() {
      var selectedPublisherId = jQuery(this).val();
      
      set_form_triplet('contact-name', jQuery(this).children(":selected").text());
      jQuery.ajax({
          dataType: "json",
          url: "/api/3/action/organization_show?include_datasets=false&id="+selectedPublisherId,
          success: function(obj) {
            if (obj.result !== undefined && obj.result.extras !== undefined){
              for (var i=0; i<obj.result.extras.length; i++){
                extras_pair=obj.result.extras[i];
                    if (extras_pair.key == 'el_posta'){
                      //user email is filled from org only if it was set this way before 
                        if (jQuery('#foi-email').val() === jQuery('#contact-email').val()){
                          set_form_triplet('foi-email', extras_pair.value);
                        }
                        set_form_triplet('contact-email', extras_pair.value);
                    }else if (extras_pair.key == 'telefon'){
                      //user phone is filled from org only if it was set this way before
                        if (jQuery('#foi-phone').val() === jQuery('#contact-phone').val()){
                          set_form_triplet('foi-phone', extras_pair.value);
                        }
                        set_form_triplet('contact-phone', extras_pair.value);
                    }else if (extras_pair.key == 'url_naslov'){
                      set_form_triplet('foi-web', extras_pair.value);
                    }else if (extras_pair.key == 'opsi_tip'){
                      jQuery('#opsi_tip').val(extras_pair.value);
                    }else if (extras_pair.key == 'opsi_tip_naziv'){
                      jQuery('#opsi_tip_naziv').val(extras_pair.value);
                    }
                }
            }
          },
          error: function(obj) {
          }
       });
      
    })
  });

  var setLicence = function(new_value, disable){
    jQuery('#licence').val(new_value); 
    if (disable){
      jQuery('#licence option:not(:selected)').prop('disabled', true);
      jQuery('#licence option:selected').prop('disabled', false);
    } else {
      jQuery('#licence option').prop('disabled', false);
    }
  };
  
  //licence autofill
  jQuery('#dostopnost_zbirke').each(function(){ 
    jQuery(this).change(function() {
      var selectedDostopnost = jQuery(this).val();
      if (selectedDostopnost == "Podatki v celoti oz. v pretežni meri niso javno dostopni") {
    	  jQuery('#pogoji_licence').val("/").prop('readonly',false);
    	  jQuery('#pogoji_licence_cena').val("/").prop('readonly',false);
          setLicence('/', false);
      } else if (selectedDostopnost == "Podatki so javno dostopni in na voljo za dostop in ponovno uporabo") {
    	  jQuery('#pogoji_licence').val("Morebitni posebni pogoji se določijo v upravni odločbi").prop('readonly',false);
    	  jQuery('#pogoji_licence_cena').val("Ni omejitve (ponovna uporaba je brezplačna)").prop('readonly',false);
          setLicence('/', false);
      } else if (selectedDostopnost == "Na voljo je spletni vpogled v podatke") {
    	  jQuery('#pogoji_licence').val("/").prop('readonly',false);
    	  jQuery('#pogoji_licence_cena').val("/").prop('readonly',false);
          setLicence('/', false);
      } else if (selectedDostopnost == "Podatki so objavljeni kot odprti podatki") {
    	  jQuery('#pogoji_licence').val("Ni omejitev (navedba vira)").prop('readonly',true);
    	  jQuery('#pogoji_licence_cena').val("Ni omejitve (ponovna uporaba je brezplačna)").prop('readonly',true);
          setLicence('Priznanje avtorstva (CC BY 4.0)', true);
      } else {
    	  jQuery('#pogoji_licence').prop('readonly',false);
    	  jQuery('#pogoji_licence_cena').prop('readonly',false);
          setLicence('Priznanje avtorstva (CC BY 4.0)', false);
      }
    })
  });
  jQuery('#dostopnost_zbirke').change();

  /* Create dialog boxes for editing the contact and foi information */
  CKAN.Dgu.setupEditorDialogs();

  /* Hide/Show the access constraints box when selecting the license_id */
  jQuery('#license_id').change(function(){
    var selectedLicense = jQuery(this).val();
    if(selectedLicense == "" || selectedLicense == "__other__"){
      jQuery('.choose-other-licence').show();
    } else {
      jQuery('.choose-other-licence').hide();
    }
  });
  jQuery('#license_id').change();

  /* Can't switch between timeseries/individual if you've got any resources */
  CKAN.Dgu.setupResourcesToggle();

  /* Validate resource buttons */
  jQuery('.validate-resources-button').each(function(index, e){ // validate all resources
    CKAN.Dgu.validateResource(e, function(){return jQuery(e).parent().find('tr.resource');});
  });
  jQuery('.validate-resource-button').each(function(index, e){ // validate individual resource
    CKAN.Dgu.validateResource(e, function(){return jQuery(e).parents('tr.resource');});
  });

  /* Save url resource button */
  jQuery('.url-save-button').each(function (index, e) { // save individual resource
    CKAN.Dgu.saveUrlResource(e, function(){return jQuery(e).parents('tr.resource');});
  });

  /* Up/down buttons */
  jQuery('.resource-move').each(function(index, button){ // validate individual resource
    button = jQuery(button);
    CKAN.Dgu.bindResourceMoveButtons(button, function(){return button.parents('tr.resource');});
  });
  /* Up/down button visibility */
  var flexitables = jQuery('.resource-move').parents('table');
  jQuery.each( flexitables, function(i,table) {
    CKAN.Dgu.setVisibleResourceMoveButtons(jQuery(table));
  });
  /* Remove buttons */
  jQuery('.resource-remove').each(function(index, button){ // validate individual resource
    button = jQuery(button);
    CKAN.Dgu.bindResourceRemoveButton(button, function(){return button.parents('tr.resource');});
  });
  /* Upload and url button visibility */
  jQuery('span.resource-id input').each(function(index, input){
    $($(input).closest('tr').find('button.url-save-button')).hide();

    if ($(input).val()){ // existing resources
      var $urlType = $($(input).closest('tr').find("input[name$='url_type']"));
      var $urlButton = $($(input).closest('tr').find('button.btn-init-url'));
      $urlButton.hide();
      if ($urlType.val() === 'upload') { // uploaded resources
        $urlButton.siblings('button.btn-init-upload').addClass('reupload');
      } else { // linked resources
        var $uploadButton = $($(input).closest('tr').find('button.btn-init-upload'));
        $uploadButton.hide();
      }
      // set listener for data changes
      var $row = $($(input).closest('tr'));
      CKAN.Dgu.changeOfRowData($row);

    } else { // new row for resource
        if ($($(input).parents('tr.additional_resource')).length > 0) {
            // set listener for data changes
            var $row = $($(input).closest('tr'));
            CKAN.Dgu.changeOfRowData($row);
        }
        else {
          $(input).closest('tr').find('td.resource-url input').hide();
        }
    }
  });

  jQuery('.btn-init-url').each(function(index, e){
	  CKAN.Dgu.initUrlButton(e);
  });
  jQuery('.btn-init-upload').each(function(index, e){
	  CKAN.Dgu.initUploadButton(e);
  });

  /* Resource format autocomplete */
  jQuery(document).on('keydown.autocomplete', function(){
    jQuery('.format-typeahead').autocomplete({source: DGU_RESOURCE_FORMATS, items:5});
  });

  /* Apply a datepicker to all date rows */
  jQuery('.needs-datepicker').datepicker({dateFormat:'dd/mm/yy'});
  
  /* Copy value of naziv_zakona v naziv_zakona_container */
  tekstovno_polje_naziv_zakona_cont = document.getElementById("naziv_zakona_container");
  tekstovno_polje_naziv_zakona = document.getElementById("naziv_zakona");
  tekstovno_polje_naziv_zakona_cont.innerHTML = tekstovno_polje_naziv_zakona.value;
  
});

/* ------------------------------------------------------------------------------ */

jQuery(function(){
  jQuery('#sop_stevilka').keyup(function(e){
      if(e.keyCode == 13) { funkcija_dobi_naziv_zakona(); }
  });
});

function sop_stevilka_button_function() {
  if (jQuery("#sop_stevilka_button").hasClass("throbbing")) return;
  funkcija_dobi_naziv_zakona();
}

function httpDobiVsebinoStrani(theUrl){
  return jQuery.ajax({
    type: "GET",
    url: theUrl,
    dataType: "json",
    timeout: 10000
  });
}

function sopSuccess(data) {
  sop_stevilka_rezultat_poizvedbe([data.name, data.url]);
}

function sopError(data) {
  sop_stevilka_rezultat_poizvedbe('Napaka pri poizvedbi SOP številke');
}

function funkcija_dobi_naziv_zakona() {

  // Reset container and input values
  jQuery('#naziv_zakona_container').html('');
  jQuery("#naziv_zakona, #naziv_zakona_lep_izpis").val('');

  var seznam_sop_stevilk_string = jQuery('#sop_stevilka').val();

  if (!seznam_sop_stevilk_string.length) {
    jQuery('#naziv_zakona').val('Ni naziva');
    jQuery('#naziv_zakona_container').html('Ni naziva');
  } else {
    // Clean up pre-existing values  and start throbbing
    
    jQuery("#sop_stevilka_button").addClass("throbbing");

    var seznam_sop_stevilk = seznam_sop_stevilk_string.split(',');
    var deferreds = [];
    var ajaxPromiseFull = $.Deferred().resolve().promise();
    seznam_sop_stevilk.forEach(function(sop_stevilka) {
      sop_stevilka = sop_stevilka.trim().replace(/ /gi, "_");
      if (!sop_stevilka.length) {
        sop_stevilka_rezultat_poizvedbe('Namesto SOP številke ste vnesli prazen niz!');
      } else {
        var ajaxPromise = httpDobiVsebinoStrani('/dataset/sop_retriever/' + sop_stevilka);
        ajaxPromiseFull = ajaxPromiseFull.then(function () {
        	return ajaxPromise;
        }).then(sopSuccess, sopError);
        deferreds.push(ajaxPromise);
      } 
    });
    
    $.when.apply($, deferreds).always(function(){
      jQuery("#sop_stevilka_button").removeClass("throbbing");
    });
  }

  return '';

}

function sop_stevilka_rezultat_poizvedbe(podatki) {

  var container_item_val = '';

  if (podatki.constructor === Array) {
    var ime = podatki[0].toString();
    var url = podatki[1].toString();
    container_item_val = '<a href="' + url + '" target="_blank">' + ime + '</a>';
  } else {
    container_item_val = podatki;
  }

  var naziv_takona_lep_izpis = jQuery("#naziv_zakona_lep_izpis").val();
  naziv_takona_lep_izpis = (naziv_takona_lep_izpis.length) ? (naziv_takona_lep_izpis + ', ' + ime) : ime;
  jQuery("#naziv_zakona_lep_izpis").val(naziv_takona_lep_izpis);

  var container = jQuery('#naziv_zakona_container');

  // Add a new line if the element is not empty
  if (jQuery.trim(container.html())) {
    container.append('<br />');
    jQuery(document).foundation('equalizer', 'reflow');
  }

  // Insert new row
  container.append('<span class="form-control field_req" rows="1" cols="60" readonly>' + container_item_val + '</span>');
  jQuery("#naziv_zakona").val(container.html());  // The value here should be the same as displayed in the preview container
}
