jQuery(function($) {
  // Truncate long .notes elements
  var notes = $('.notes');
  notes.dotdotdot({
    height: 230,
    tolerance: 10,
    after: 'a.notes-read-more'
  });
  notes.trigger('isTruncated', function(isTruncated) {
    if (!isTruncated) {
      notes.find('a.notes-read-more').remove();
    }
    else {
      var more = notes.find('a.notes-read-more');
      more.css('display', 'block');
      more.click(function(e) {
        e.preventDefault();
        $('.notes').trigger('destroy.dot');
        notes.find('a.notes-read-more').remove();
        $(document).foundation('equalizer', 'reflow');
        return false;
      });
    }
  });

  var license_info = $('#license-info');
  license_info.dotdotdot({
    height: 50,
    tolerance: 10,
    after: 'a.license-read-more'
  });
  license_info.trigger('isTruncated', function(isTruncated) {
    if (!isTruncated) {
      license_info.find('a.license-read-more').remove();
    }
    else {
      var more = license_info.find('a.license-read-more');
      more.click(function(e) {
        e.preventDefault();
        $('#license-info').trigger('destroy.dot');
        license_info.find('a.license-read-more').remove();
        return false;
      });
    }
  });

  var spinConfig = {
    lines: 9, // The number of lines to draw
    length: 5, // The length of each line
    width: 2, // The line thickness
    radius: 6, // The radius of the inner circle
    rotate: 3, // The rotation offset
    color: '#777', // #rgb or #rrggbb
    speed: 2.1, // Rounds per second
    trail: 43, // Afterglow percentage
    shadow: false, // Whether to render a shadow
    hwaccel: false, // Whether to use hardware acceleration
    className: 'spinner', // The CSS class to assign to the spinner
    zIndex: 2e9, // The z-index (defaults to 2000000000)
    top: 'auto', // Top position relative to parent in px
    left: 'auto' // Left position relative to parent in px
  };

  /*
  function comments() {
    $('.replies-header').each(function(index) {
        var comment_type = $(this).text();
        $(this).prepend('<a class="comments-collapse expanded pull-right" href="#">Collapse all ' + comment_type.toLowerCase() + ' <i class="icon-collapse-top"></i></a>');
    });

    $('.comments-collapse').click(function(){
        $(this).toggleClass('expanded');
        if ($(this).hasClass('expanded')) {
            $(this).parent().parent().find('.reply-body').show();
            $(this).parent().parent().find('.reply').removeClass('collapsed');
            $(this).parent().parent().find('.comment-collapse').addClass('expanded');
            $(this).parent().parent().find('.comment-collapse').html('<i class="icon-collapse-top"></i>');
            //$(this).html('Collapse all comments <i class="icon-collapse-top"></i>' + $(this).html());
            $(this).html($(this).html().replace('Expand', 'Collapse'));
            $(this).children('i').removeClass('icon-expand');
            $(this).children('i').addClass('icon-collapse-top');
        }
        else {
            $(this).parent().parent().find('.reply-body').hide();
            $(this).parent().parent().find('.reply').addClass('collapsed');
            $(this).parent().parent().find('.comment-collapse').removeClass('expanded');
            $(this).parent().parent().find('.comment-collapse').html('<i class="icon-expand"></i>');
            //$(this).html('Expand all comments <i class="icon-expand"></i>' + $(this).html() );
            $(this).html($(this).html().replace('Collapse', 'Expand'));
            $(this).children('i').removeClass('icon-collapse-top');
            $(this).children('i').addClass('icon-expand');
        }
        return false;
    });

    $('body:not(.page-reply) .reply .inner').prepend('<a title="Collapse this comment" class="comment-collapse expanded" href="#"><i class="icon-collapse-top"></i></a>');
    $('.comment-collapse').click(function(){
        $(this).toggleClass('expanded');
        $(this).parent().parent().toggleClass('collapsed');
        if ($(this).hasClass('expanded')) {
            $(this).parent().find('.reply-body').show();
            $(this).html('<i class="icon-collapse-top"></i>');
            $(this).prop('title', 'Collapse this comment');
        }
        else {
            $(this).parent().find('.reply-body').hide();
            $(this).html('<i class="icon-expand"></i>');
            $(this).prop('title', 'Expand this comment');
        }
        return false;
    });

    $('body:not(.page-reply) .reply:not(.parent-0)').prepend('<a title="See start of thread" class="go-to-parent" href="#"><i class="icon-circle-arrow-up"></i></a>');
    $('.go-to-parent').click(function(){
        var parent = $(this).parent().attr("class").match(/parent-(\d*)/)[1];
        $('html, body').animate({'scrollTop' : $('#reply-' + parent).offset().top - 50},800, 'swing', function(){
            $('#reply-' + parent).fadeOut(100);
            $('#reply-' + parent).fadeIn(200);
        });
        return false;
    });
  }
  
  // Create a spinner in the comments loader
  var spinDiv = $('.comments-spinner')[0];
  var commentsSpinner = new Spinner(spinConfig).spin(spinDiv);

  // DATASET_ID is only set on dataset page, not on resource page.
  if('DATASET_ID' in window) {
    var url = '/comment/get/'+window.DATASET_ID+'?comments_per_page=999999';
    $.ajax({
            url: url,
            data: '',
            dataType: 'html',
            success: function(data, textStatus, xhr) {
              commentsSpinner.stop();
              $('#comments-container').html(data);
              comments();
            },
            error: function(xhr, status, exception) {
              commentsSpinner.stop();
              $(spinDiv).hide();
              $('#comments .boxed')
                .append('Error loading comments: <code>'+url+'</code><br/><br/>')
                .append($('<pre>').text(JSON.stringify(exception)));
            }
          });
  }
  */

  // Year segmentation
  $(".year .year_items").hide();
  $(".year .year_items").first().show();

  // 'View More' and 'View Less' are hidden by default so
  // that viewers without javascript cannot see them

  // Show the first 'View Less' button
  $(".year .hideyear").first().show();

  // Show all but the first 'View More' button
  $(".year .showyear").show();
  $(".year .showyear").first().hide();

  $(".year h3 span.showyear").on('click', function(){
    $(this).parent().next('.year_items').fadeIn();
    $(this).siblings('.hideyear').show();
    $(this).hide();
    $(document).foundation('equalizer', 'reflow');
    return false;
  });
  $(".year h3 span.hideyear").on('click', function(){
    $(this).parent().next('.year_items').fadeOut();
    $(this).siblings('.showyear').show();
    $(this).hide();
    $(document).foundation('equalizer', 'reflow');
    return false;
  });

 // Closed issues
  $(".hide-closed-issues").hide();
  $("#issue-list-closed").hide();
  $("span.show-closed-issues").on('click', function(){
    $(this).parent().next('.issue-list-group').fadeIn();
    $(this).siblings('.hide-closed-issues').show();
    $(this).hide();
    $(document).foundation('equalizer', 'reflow');
    return false;
  });
  $("span.hide-closed-issues").on('click', function(){
    $(this).parent().next('.issue-list-group').fadeOut();
    $(this).siblings('.show-closed-issues').show();
    $(this).hide();
    $(document).foundation('equalizer', 'reflow');
    return false;
  });

  $('.ckan-container').on('hidden.bs.collapse shown.bs.collapse', function () {
    $(document).foundation('equalizer', 'reflow');
  });
});


