﻿/* Force an event handler to run in the context of its parent object */
var __bind = function (fn, me) {
  return function () {
    return fn.apply(me, arguments);
  };
};

/* Utility: Global assertion function */
function assert(code, errorMessage) {
  if (!code) {
    console.error(errorMessage, arguments);
    throw ('AssertionError');
  }
}

function feedback_publish(itemid) {
  $.ajax({
    url: "/data/feedback/moderate/" + itemid,
    data: {action: 'publish'},
    dataType: "json",
    method: "POST",
    success: function () {
      $('#' + itemid).slideUp('slow')
      return false
    }
  })
  return false
}

function feedback_delete(itemid, andban) {
  var data = {action: 'delete'}
  if (andban) {
    data['action'] = 'delete_and_ban'
  }
  $.ajax({
    url: "/data/feedback/moderate/" + itemid,
    data: data,
    dataType: "json",
    method: "POST",
    success: function () {
      $('#' + itemid).slideUp('slow')
      return false
    }
  })
  return false
}

/* Utility: Global console.log() function for all browsers */
(function (con) {
  var method;
  var dummy = function () {
  };
  var methods = ('assert,count,debug,dir,dirxml,error,exception,group,' +
      'groupCollapsed,groupEnd,info,log,markTimeline,profile,profileEnd,' +
      'time,timeEnd,trace,warn').split(',');
  while (method = methods.pop()) {
    con[method] = con[method] || dummy;
  }
})(window.console = window.console || {});


/* Core JS */
jQuery(function ($) {
  // Init jquery.placeholder plugin
  $('input[placeholder], textarea[placeholder]').placeholder();
  // Init jquery.chosen plugin
  $(".chzn-select").chosen();

  /* Create javascript tooltips */
  $('.js-tooltip').tooltip();
  $('.js-tooltip-instruction-needed').attr('title', 'Tooltip text required?');
  $('.js-tooltip-instruction-needed').tooltip({'extraClass': 'instruction-needed'});

  $('.instruction-needed').tooltip({'extraClass': 'instruction-needed'});

  $('.to-be-completed').addClass('js-tooltip-to-be-completed');
  $('.js-tooltip-to-be-completed').tooltip({'extraClass': 'to-be-completed'});

  /* Star ratings have gorgeous HTML tooltips */
  $('.star-rating').each(function (i, el) {
    el = $(el);
    el.tooltip({
      title: el.find('.tooltip').html(),
      html: true,
      placement: 'right',
      template: '<div class="tooltip star-rating-tooltip"><div class="tooltip-arrow"></div><div class="tooltip-inner"></div></div>',
      delay: 300,
    });
  });

  /* Reveal in search results facets */
  $('.facet-expand-collapse').click(function (e) {
    e.preventDefault();
    var target = $(e.delegateTarget); // Using e.target might accidently catch the <img>
    var id = target.attr('id');
    target.toggleClass('expanded');
    $('.more-' + id).toggle('fast', function () {
      $(document).foundation('equalizer', 'reflow');
    });
  });

  $('.read-more-parent .link-read-more, .read-more-parent .link-read-less').click(function (e) {
    e.preventDefault();
    var target = $(e.delegateTarget);
    var expand = target.hasClass('link-read-more');
    var parentElement = target.parents('.read-more-parent');
    if (expand) {
      parentElement.find('.expanded').show('fast');
      parentElement.find('.collapsed').hide();
    } else {
      parentElement.find('.collapsed').show('fast');
      parentElement.find('.expanded').hide();
    }
  });

  $('select[name="sort"]').change(function (e) {
    e.preventDefault();
    $('#search-sort-by').submit();
  });
  $('input[name="publisher-results-include-subpub"]').change(function (e) {
    e.preventDefault();
    var checkbox = $(e.delegateTarget);
    var container = checkbox.parents('.search-area');
    if (checkbox.is(':checked')) {
      var hiddenInput = container.find('input[type="hidden"][name="publisher"]');
      hiddenInput.attr('name', 'parent_publishers');
    } else {
      var hiddenInput = container.find('input[type="hidden"][name="parent_publishers"]');
      hiddenInput.attr('name', 'publisher');
    }
  });
  $('input[name="checkbox-submit-on-change"]').change(function (e) {
    e.preventDefault();
    window.location = $(this).val();
  });

  // Buttons with href-action should navigate when clicked
  $('input.href-action').click(function (e) {
    e.preventDefault();
    window.location = ($(e.target).attr('action'));
  });

  $('input#search-theme-mode').change(CKAN.Dgu.toggleSearchThemeMode);

  // Set up user login state
  if (CKAN.USER) {
    $(".ckan-logged-out").hide();
    $(".ckan-logged-in").show();
  }

  // Show/hide facets
  $('a.show-facets, a.hide-facets').click(function (e) {
    e.preventDefault();
    if ($(e.delegateTarget).hasClass('show-facets')) {
      $('.facet-filters').addClass('in');
    } else {
      $('.facet-filters').removeClass('in');
    }
    return false;
  });

  $('li.em-encoded a').each(function (e) {
    var encoded = $(this).text();
    var decoded = '';
    for (var i = 0; i < encoded.length; i++) {
      if (i % 2 == 0) {
        decoded = decoded + encoded[i];
      }
    }
    $(this).text(decoded);
    $(this).attr('href', 'mailto:' + decoded);
  });
});

var CKAN = CKAN || {};

CKAN.Dgu = function ($, my) {
  $('document').ready(function () {
    my.toggleSearchThemeMode = function (e) {
      var isChecked = !!($(e.delegateTarget).attr('checked'));
      $('.facets-theme-primary').addClass(isChecked ? 'enabled' : 'disabled').removeClass(isChecked ? 'disabled' : 'enabled');
      $('.facets-theme-all').addClass(isChecked ? 'disabled' : 'enabled').removeClass(isChecked ? 'enabled' : 'disabled');
    };

    my.setupEditorDialogs = function () {
      // Bind to the 'save' button, which writes values back to the document
      $('.dgu-editor-save').click(function (e) {
        var inputs = $(e.target).parents('.dgu-editor').find('input');
        $.each(inputs, function (i, input) {
          input = $(input);
          var targetLabel = input.attr('data-label');
          var targetInput = input.attr('data-input');
          // Update the text label in the page
          if (targetLabel) {
            $(targetLabel).text(input.val());
          }
          // Update the hidden input which stores the true value
          if (targetInput) {
            $(targetInput).val(input.val());
          }
        });
      });

      $('.dgu-editor').on('shown', function (e) {

        // Populate the inputs with the values of their targets.
        var modal = $(e.target);
        var inputs = modal.find('input');
        $.each(inputs, function (i, input) {
          input = $(input);
          var targetInput = input.attr('data-input');
          if (targetInput) {
            input.val($(targetInput).val());
          }
        });

        // Be nice. Focus the first input when the dialog appears.
        var firstInput = $(e.target).find('input')[0];
        $(firstInput).focus();
      });

      $('.dgu-editor input[type="text"]').bind('keydown', function (e) {
        // Capture the Enter key
        if (e.keyCode == 13) {
          // DO NOT SUBMIT THE FORM! (Really annoying!)
          e.preventDefault();
          // Instead, confirm the dialog box
          $(e.target).parents('.dgu-editor').find('.dgu-editor-save').click();
        }
      });
    };

    var isUploadingUrl = false;
    var isDeletingResource = false;
    var storedResourceType = 'any'; //track stored type so we do not upload a different resource type than are currently stored
    my.setupResourcesToggle = function () {
      var cancel = false; // flag for modal cancel
      var uploading = false;
      var deleting = false;

      function clickToggle(e) {
        e.preventDefault();
        if (uploading) {
          uploading = false;
          return;
        }
        if (cancel) {
          cancel = false;
          return;
        }
        if (deleting) {
          deleting = false;
          return;
        }
        var additionalResourceTable = $('#additional_resources-table')[0];
        var to = e.target.value;
        var showModal = false;
        if (isUploadingUrl || $('#fileForm').hasClass('uploading')) {
          uploading = true;
          alert("Prosimo, počakajte, da bo datoteka naložena!");
          $('input:radio[name=package_type]:not(:checked)').click();
          return;
        }
        if (isDeletingResource) {
          deleting = true;
          alert("Datoteka se briše, prosimo počakajte na izbris vrstice.");
          $('input:radio[name=package_type]:not(:checked)').click();
          return;
        }

        if (to === 'individual') {
          var resourceTable = $('#timeseries_resources-table')[0];
          $(resourceTable).find('tr .resource-id').each(function (index, e) {
            if ($(this).find('input').val()) {
              showModal = true;
            }
          });
          if (showModal) {
            $('#package_type_modal').foundation('reveal', 'open');
          } else {
            doToggle(to);
          }
        } else {
          var resourceTable = $('#individual_resources-table')[0];
          $(resourceTable).find('tr .resource-id').each(function (index, e) {
            if ($(this).find('input').val()) {
              showModal = true;
            }
          });
          if (showModal) {
            $('#package_type_modal2').foundation('reveal', 'open');
          } else {
            doToggle(to);
          }
        }
      }

      function cancelChange(e) {
        e.preventDefault();
        // sets variable, that tells if modal was canceled, otherwise another modal would pop up
        cancel = true;
        var active = $('input:radio[name=package_type]:not(:checked)').click();
      }

      function doToggle(mode) {
        var alt;
        if (mode == 'individual') alt = 'timeseries';
        else if (mode == 'timeseries') alt = 'individual';
        else throw 'Cannot toggle to mode=' + mode;
        var from = $('#' + alt + '_resources-table');
        var to = $('#' + mode + '_resources-table');

        // reset storedResourceType to "any" if no resources have id
        var noResource = true;
        $('#timeseries_resources-table, #individual_resources-table').find('tr .resource-id').each(function (index, e) {
          if ($(this).find('input').val()) {
            noResource = false;
          }
        });
        if (noResource) {
          storedResourceType = "any"
        }

        // check if any resources are saved and set stored type if they are, but only the first time
        if ($('fieldset#package_type-' + alt).find('.resource-id > input[value!=""][value]').length > 0 && storedResourceType == "any")
          storedResourceType = alt + "_resource";

        // Copy the data
        CKAN.Dgu.copyResourceTable(from, to);
        // Wipe the old table
        var newRow = CKAN.Dgu.addTableRow(from, true);
        from.find('tbody tr').not(newRow).remove();
        CKAN.Dgu.showHideResourceFieldsets();
      }

      $('#package_type_modal .cancel').click(cancelChange);
      $('#package_type_modal2 .cancel').click(cancelChange);
      $('#package_type_modal .ok').click(function () {
        doToggle('individual')
      });
      $('#package_type_modal2 .ok').click(function () {
        doToggle('timeseries')
      });
      $('input:radio[name=package_type]').change(clickToggle);
    };

    /* Toggling visibility of time-series/data resources */
    my.showHideResourceFieldsets = function () {
      var isTimeseries = $('input#package_type-timeseries-radio').is(':checked');
      var isIndividual = $('input#package_type-individual-radio').is(':checked');
      var fieldsetTimeseries = $('fieldset#package_type-timeseries');
      var fieldsetIndividual = $('fieldset#package_type-individual');
      if (isTimeseries) {
        fieldsetTimeseries.show();
        fieldsetIndividual.hide();
      } else {
        fieldsetTimeseries.hide();
        fieldsetIndividual.show();
      }
    };

    my.copyResourceTable = function (_from, _to) {
      var from = _from.find('tbody tr');
      var to = _to.find('tbody tr');
      while (to.length < from.length) {
        to.push(CKAN.Dgu.addTableRow(_to));
      }
      for (var i = 0; i < from.length; i++) {
        // Map out the target elements; { 'url':<HTMLInput> .. }
        var inputMap = {};
        $.each($(to[i]).find('input'), function (ii, input) {
          input = $(input);
          var name = input.prop('name').split('__')[2];
          inputMap[name] = input;
        });
        // Copy from the source elements
        $.each($(from[i]).find('input'), function (ii, input) {
          input = $(input);
          var name = input.prop('name').split('__')[2];
          if (name in inputMap) {
            inputMap[name].val(input.val())
            if (name == 'url') {
              if (input.is(":visible"))
                inputMap[name].show();
              else
                inputMap[name].hide();
            }
          }
        });
        // Copy from the source hidden elements, even if they do not exist in target (needed to transfer displayed: false and similar fields)
        var fromType = _from.prop('id').split('_')[0];
        var toType = _to.prop('id').split('_')[0];
        $.each($(from[i]).find('div.hidden-resource-fields > input'), function (ii, input) {
          var clonedHidden = $(input).clone();
          var newId = clonedHidden.prop('id').replace(fromType, toType);
          var newName = clonedHidden.prop('name').replace(fromType, toType);
          clonedHidden.prop('id', newId);
          clonedHidden.prop('name', newId);
          $(to[i]).find('div.hidden-resource-fields').append(clonedHidden);
        });
        // Map out visibility of target buttons;
        var visibilityMap = {};
        $.each($(to[i]).find('button'), function (ii, button) {
          button = $(button);
          var name = button.prop('id').split('__')[2];
          visibilityMap[name] = button;
        });
        // Copy from the source buttons
        $.each($(from[i]).find('button'), function (ii, button) {
          button = $(button);
          var name = button.prop('id').split('__')[2];
          if (name in visibilityMap) {
            if (button.is(":visible"))
              visibilityMap[name].show();
            else
              visibilityMap[name].hide();
          }
        });
        //init rows for upload or reupload
        var res_id = $(from[i]).find(".resource-id > input").val();

        if (res_id) { //init reupload button for stored resources
          $(to[i]).find(".btn-init-upload").addClass('reupload');
          CKAN.Dgu.initUploadButton($(to[i]).find(".btn-init-upload"));
        } else { //init complete form for non-stored resource rows
          var urlButton = $(to[i]).find(".btn-init-url");
          var uploadButton = $(to[i]).find(".btn-init-upload");
          CKAN.Dgu.initUrlButton(urlButton);
          CKAN.Dgu.initUploadButton(uploadButton);
          if ($(from[i]).find('.btn-init-upload').text() === "Shrani") {
            $(to[i]).find('.btn-init-upload').text("Shrani");
            CKAN.Dgu.fileInputChange(uploadButton);
          }
        }
      }
    };

    var individualResourceTableRow;
    var timeseriesResourceTableRow;
    var additionalResourceTableRow;
    my.setRow = function () {
      var individualResourceTable = $('#individual_resources-table')[0];
      var timeseriesResourceTable = $('#timeseries_resources-table')[0];
      var additionalResourceTable = $('#additional_resources-table')[0];
      individualResourceTableRow = $(individualResourceTable).find('tbody tr:last');
      timeseriesResourceTableRow = $(timeseriesResourceTable).find('tbody tr:last');
      additionalResourceTableRow = $(additionalResourceTable).find('tbody tr:last');
    };
    my.setRow();

    my.getRow = function (tableType) {
      if (tableType === "individual") return individualResourceTableRow;
      if (tableType === "timeseries") return timeseriesResourceTableRow;
      if (tableType === "additional") return additionalResourceTableRow;
    };

    // if restart_index is defined and true, the new row will be inited with index 0, presuming that all other rows will be deleted after
    my.addTableRow = function (table, restart_index) {
      var lastRow = table.find('tbody tr:last');
      if (lastRow.length < 1) {
        lastRow = my.getRow(table.attr('id').split('_')[0]);
      }

      var oldClass = lastRow.prop('class');
      var info = oldClass.split('__'); // eg. additional_resources__0
      var prefix = info[0];
      var newIndex = parseInt(info[1], 10) + 1;
      if (restart_index) {
        newIndex = 0;
      }
      var newRow = lastRow.clone();
      newRow.removeClass(oldClass);
      newRow.addClass(prefix + "__" + newIndex);
      if (lastRow.hasClass('individual_resource'))
        newRow.addClass('individual_resource');
      else if (lastRow.hasClass('timeseries_resource'))
        newRow.addClass('timeseries_resource');
      else if (lastRow.hasClass('additional_resource'))
        newRow.addClass('additional_resource');
      newRow.addClass('resource');

      if (table.find('tbody tr:last').length < 1) {
        var tbody = table.find('tbody');
        tbody.append(newRow);
      } else {
        newRow.insertAfter(lastRow);
      }
      newRow.find("*").each(function (index, node) {
        var attrValueRegex = new RegExp(prefix + '__\\d+');
        var replacement = prefix + '__' + newIndex;

        if ($(node).prop("for")) {
          $(node).prop("for", $(node).prop("for").replace(attrValueRegex, replacement));
        }
        if ($(node).prop("name")) {
          $(node).prop("name", $(node).prop("name").replace(attrValueRegex, replacement));
        }
        if ($(node).prop("id")) {
          $(node).prop("id", $(node).prop("id").replace(attrValueRegex, replacement));
        }
        if ($(node).attr("value")) {
          $(node).attr("value", "");
        }
        $(node).val("");
        $(node).removeClass("error");
      });
      //remove hidden input fields of saved resources:
      newRow.find('div.hidden-resource-fields > input').remove();
      //fix upload/url buttons
      newRow.find('.url-save-button').hide();
      newRow.find('.upload-error').hide();
      newRow.find('.upload-success').hide();
      newRow.find('.btn-init-upload').prop('disabled', false);
      newRow.find('.resource-remove').prop('disabled', false);

      // Check URL button
      var validateButton = newRow.find('button[id$="__validate-resource-button"]');
      if (validateButton.length == 0) {
        jQuery(document).foundation('equalizer', 'reflow');
        throw 'Bad CSS selector. Could not attach event handler.';
      }
      validateButton.attr('value', 'Check')
          .removeAttr('disabled')
          .each(function (index, e) {
            CKAN.Dgu.validateResource(e, function () {
              return $($(e).parents('tr')[0]);
            });
          });

      // Save URL button - present, if dataset's state is active or draft (it can be None, if new)
      /** If save button exist, set click listener for saving url resource */
      var saveUrlButton = newRow.find('button[id$="__url-save-button"]');
      if (saveUrlButton.length > 0) {
        saveUrlButton.each(function (index, e) {
          CKAN.Dgu.saveUrlResource(e, function () {
            return $($(e).parents('tr.resource'));
          })
        });
      }
      // set listner for data changes
      CKAN.Dgu.changeOfRowData(newRow);
      // Up/Down buttons
      $.each(newRow.find('.resource-move'), function (i, button) {
        CKAN.Dgu.bindResourceMoveButtons($(button));
      });
      $.each(newRow.find('.resource-remove'), function (i, button) {
        CKAN.Dgu.bindResourceRemoveButton($(button));
      });
      // Reset button visiblity
      CKAN.Dgu.setVisibleResourceMoveButtons(table);
      // Date rows think they have a datepicker applied, but they are copies. They don't.
      newRow.find('.needs-datepicker').removeClass('hasDatepicker');
      // So give them a datepicker:
      newRow.find('.needs-datepicker').datepicker({dateFormat: 'dd/mm/yy'});
      jQuery(document).foundation('equalizer', 'reflow');
      return newRow;
    };

    my.initUrlButton = function (urlButton) {
      $(urlButton).click(function (e) {
        e.stopPropagation();
        //enable url field, hide upload and url button, show validation and save button
        $(urlButton).siblings(".btn-init-upload").hide();
        $(urlButton).hide();
        $(urlButton).siblings(".validate-resource-button").show();
        var noResource = true;
        // allow saving resources if no resources of other type are saved
        $('#timeseries_resources-table, #individual_resources-table').find('tr .resource-id').each(function (index, e) {
          if ($(this).find('input').val()) {
            noResource = false;
          }
        });
        if (storedResourceType === "any"
            || $(urlButton).closest('tr').hasClass(storedResourceType)
            || noResource) {
          $(urlButton).siblings(".url-save-button").show();
        }
        $(urlButton).siblings("span").find("input").show();
        $(urlButton).siblings("span.upload-error").hide();
        jQuery(document).foundation('equalizer', 'reflow');
      });
    };

    my.normalizeUrl = function (url) {
      var toHttps = $("#dataset-edit").hasClass("using-https");
      if (toHttps && url.indexOf('http:') === 0) {
        return 'https' + url.slice(4);
      }
      return url;
    }

    my.isJSON = function (text) {
      var t = text.trim();
      return t.length >= 2 && (t.charAt(0) == '[' && t.charAt(t.length - 1) == ']' || t.charAt(0) == '{' && t.charAt(t.length - 1) == '}');
    }

    my.setUploadResultHandler = function (uploadButton) {
      var reupload = $(uploadButton).hasClass('reupload');
      var $fileFrame = $('#fileFrame');
      $fileFrame.off();
      $fileFrame.load(function () {
        $('#fileForm').removeClass('uploading');
        $(uploadButton).prop('disabled', false);
        $(uploadButton).removeClass("throbbing");
        $(uploadButton).siblings("span.error").hide();
        $(uploadButton).siblings("span.upload-success").hide();
        $(uploadButton).siblings(".url-save-button").hide();
        var error = "Pri prenosu je prišlo do nepričakovane napake. Prosimo, poskusite ponovno kasneje.";
        var iframedocument = this.contentDocument;
        var contentType = iframedocument.contentType || iframedocument.mimeType;
        var textContent = $fileFrame.contents().text();
        if (contentType == "application/json" || CKAN.Dgu.isJSON(textContent)) {
          try {
            var response = $.parseJSON(textContent);
            if (response.success) {
              $(uploadButton).siblings('span').find('input:text').each(function (index, element) {
                $(element).val(CKAN.Dgu.normalizeUrl(response.result.url));
              });
              $(uploadButton).closest('tr').find('.resource-type > input').val('file');
              if (!reupload) {
                $(uploadButton).closest('tr').find('.resource-id > input').val(response.result.id);
              }
              $(uploadButton).removeClass("btn-upload-chosen");
              $(uploadButton).addClass("reupload");
              CKAN.Dgu.initUploadButton(uploadButton); //reset the button handlers and possibly change text
              $(uploadButton).siblings('.validate-resource-button').show();
              error = false;
              $(uploadButton).siblings("span.upload-success").text(
                  "Datoteka je bila uspešno shranjena. Ta sprememba ne zahteva ponovnega potrjevanja, " +
                  "zato lahko urejanje zaključite s pritiskom na gumb 'Nazaj na zbirko'.");
              $(uploadButton).siblings("span.upload-success").show();
              CKAN.Dgu.changeOfRowData($(uploadButton).closest("tr"));
            } else {
              if (response.error) {
                if (response.error.upload) {
                  if (response.error.upload.constructor === Array && $.inArray("File upload too large", response.error.upload) != -1)
                    error = "Velikost datoteke je prevelika";
                  else
                    error = "Napaka: " + JSON.stringify(response.error.upload);
                } else if (response.error.message)
                  error = response.error.message;
                else
                  error = "Napaka OPSI: " + JSON.stringify(response.error);
                if (!reupload)
                  CKAN.Dgu.initForUpload($(uploadButton).closest("tr"));
              }
            }
          } catch (e) {
            error = "Napaka v odgovoru OPSI: " + JSON.stringify(e);
          }
        } else if (textContent.includes("413 Request Entity Too Large")) {
          error = "Prevelika datoteka. Prosimo, sporočite skrbnikom, da preverijo omejitve";
        }
        if (error)
          alert(error);
      });
    }

    my.submitFileUpload = function (uploadButton, fileName, description, format, date, refreshInterval) {
      var reupload = $(uploadButton).hasClass('reupload');
      var isTimeseries = $(uploadButton).closest("tr").hasClass("timeseries_resource");
      var $fileForm = $('#fileForm');
      var valid = true;

      //validate
      if (!fileName) {
        alert("Vpisati morate lokacijo datoteke!");
        valid = false;
      }
      if (!description) {
        alert("Vpisati morate ime datoteke!");
        valid = false;
      }
      if (!format) {
        alert("Vpisati morate format datoteke!");
        valid = false;
      }
      if (isTimeseries && date === "") {
        alert("Vpisati morate datum datoteke!");
        valid = false;
      }
      if (isTimeseries && refreshInterval === "") {
        alert("Vpisati morate pogostost osveževanja!");
        valid = false;
      }

      if (valid) {
        $fileForm.find('input[name="name"]').val(fileName);
        $fileForm.find('input[name="description"]').val(description);
        $fileForm.find('input[name="format"]').val(format);
        $fileForm.find('input[name="url_type"]').val('upload');
        $fileForm.find('input[name="resource_type"]').val('file');
        $fileForm.find('input[name="pogostost_osvezevanja"]').val(refreshInterval);
        if (isTimeseries) {
          $fileForm.find('input[name="date"]').val(date);
        } else {
          $fileForm.find('input[name="date"]').val("");
        }
        $(uploadButton).addClass("throbbing");
        $(uploadButton).prop('disabled', true);
        $(uploadButton).siblings("span.upload-error").text("Prenos v poteku.");
        $(uploadButton).siblings("span.upload-error").addClass('error');
        // to prevent jumping content
        var width = $(uploadButton).closest("table").find("th.resource-url").outerWidth();
        $(uploadButton).closest("table").find("th.resource-url").css("width", width);
        $(uploadButton).siblings("span.upload-error").show();
        jQuery(document).foundation('equalizer', 'reflow');
        if (reupload) {
          $fileForm.attr("action", "/api/3/action/resource_update");
          var resource_id = $(uploadButton).closest('tr').find('.resource-id > input').val();
          $fileForm.find('input[name="id"]').val(resource_id);
        } else {
          $fileForm.attr("action", "/api/3/action/resource_create");
          $fileForm.find('input[name="url"]').val('');
          $(uploadButton).closest('tr').find('.resource-url-type > input').val('upload');
        }
        $fileForm.addClass('uploading');
        $fileForm.submit();
        CKAN.Dgu.cleanFileForm($fileForm);
      }
    };

    my.cleanFileForm = function () {
      var $fileForm = $('#fileForm');
      $fileForm.find('input[name="upload"]').val("");
    };

    my.changeOfRowData = function (row) {
      $(row).change(function (e) {
        var saveUrlButton = $(row).find(".url-save-button");
        if (storedResourceType === "any" || $(saveUrlButton).closest('tr').hasClass(storedResourceType)
            || $(saveUrlButton).closest('tr').hasClass('additional_resource')) {
          if ($(row).find('.btn-init-upload').text() !== 'Shrani')
            $(saveUrlButton).show();
        }
      })
    };

    /** Sets click listener for saving url resource*/
    my.saveUrlResource = function (button, getResource) {
      $(button).click(function (e) {
        e.stopPropagation();
        $(button).siblings("span.error").hide();
        $(button).siblings("span.upload-success").hide();

        /** Check that resource can be saved */
        var noResource = true;
        // allow saving resources if no resources of other type are saved
        $('#timeseries_resources-table, #individual_resources-table').find('tr .resource-id').each(function (index, e) {
          if ($(this).find('input').val()) {
            noResource = false;
          }
        });
        var isSameType = noResource || storedResourceType === "any" || $(button).closest('tr').hasClass(storedResourceType);
        if (!isSameType) {
          $(button).siblings("span.upload-error").text("Po menjavi tipa vnosa (enkraten/periodičen) mora biti zbirka pred shranjevanjem datotek ponovno shranjena.");
          $(button).siblings("span.upload-error").addClass('error');
          // to prevent jumping content
          var width = $(button).closest("table").find("th.resource-url").outerWidth();
          $(button).closest("table").find("th.resource-url").css("width", width);
          $(button).siblings("span.upload-error").show();
          jQuery(document).foundation('equalizer', 'reflow');
          return;
        }

        $(this).attr({'disabled': 'disabled'});
        var resource = getResource();
        var urlResourceValue = $(resource).map(function () {
          return $(this).find('input[name$="__url"]').val();
        });
        var packageId = $('#fileForm input[name="package_id"]').val();
        var resourceId = $(button).closest("tr").find(".resource-id").find("input").val();
        var descriptionInput = $(button).closest("td").siblings(".resource-description").find("input").val();
        var formatInput = $(button).closest("td").siblings(".resource-format").find("input").val();
        var $dateInput = $(button).closest("td").siblings(".resource-date").find("input");
        var date = $dateInput.length === 0 ? '' : $dateInput.val();
        var $urlTypeInput = $(button).closest("tr").find(".resource-url-type").find("input");
        var url_type = $urlTypeInput.length === 0 ? '' : $urlTypeInput.val();
        var $nameInput = $(button).closest("tr").find(".resource-name").find("input");
        var name = $nameInput.length === 0 ? '' : $nameInput.val();
        var refreshInterval = $('#pogostost_osvezevanja').children(":selected").val();
        var valid = true;

        var isTimeseries = $(button).closest("tr").hasClass("timeseries_resource");
        //validate
        if (isTimeseries && date === '') {
          alert("Vpisati morate datum datoteke!");
          valid = false;
        }
        if (isTimeseries && refreshInterval === "") {
          alert("Vpisati morate pogostost osveževanja!");
          valid = false;
        }
        if (!descriptionInput) {
          alert("Vpisati morate ime datoteke!");
          valid = false;
        }
        if (!formatInput) {
          alert("Vpisati morate format datoteke!");
          valid = false;
        }
        if (!urlResourceValue[0]) {
          alert("Vpisati morate URL!");
          valid = false;
        }

        var resourceType = "file";
        if ($(this).parents('tr.additional_resource').length > 0) {
          resourceType = "documentation";
        }
        if (valid) {
          isUploadingUrl = true;
          resource_data = {
            "id": resourceId,
            "package_id": packageId,
            "url": urlResourceValue[0],
            "description": descriptionInput,
            "pogostost_osvezevanja": refreshInterval,
            "format": formatInput,
            "resource_type": resourceType
          }
          //copy hidden input fields of existing resources
          if (name != '') {
            resource_data["name"] = name;
          }
          if (url_type != '') {
            resource_data["url_type"] = url_type;
          }
          //copy date for timeseries
          if (date != '') {
            resource_data["date"] = date;
          }

          if (resourceId.length !== 0) {
            $.ajax({
              url: "/api/3/action/resource_update",
              dataType: 'json',
              data: JSON.stringify(resource_data),
              cache: false,
              type: "POST",
              success: function (data) {
                $(button).removeAttr('disabled');
                $(button).hide();
                $(button).closest("tr").find(".resource-id").find("input").val(data.result.id);
                isUploadingUrl = false;
                $(button).siblings("span.upload-success").text(
                    "Datoteka je bila uspešno spremenjena. Ta sprememba ne zahteva ponovnega potrjevanja, " +
                    "zato lahko urejanje zaključite s pritiskom na gumb 'Nazaj na zbirko'.");
                // to prevent jumping content
                var width = $(button).closest("table").find("th.resource-url").outerWidth();
                $(button).closest("table").find("th.resource-url").css("width", width);
                $(button).siblings("span.upload-success").show();
                setTimeout(function () {
                  $(button).siblings("span.upload-success").css('opacity', '0');
                  setTimeout(function () {
                    $(button).siblings("span.upload-success").hide();
                  }, 3000);
                }, 10000);
              },
              error: function (xhr) {
                $(button).removeAttr('disabled');
                $(button).hide();
                var $upload_error = $(button).siblings("span.upload-error");
                $upload_error.text("Napaka " + xhr.status + " pri shranjevanju povezave: " + xhr.responseJSON.error.message);
                $upload_error.addClass('error');
                // to prevent jumping content
                var width = $(button).closest("table").find("th.resource-url").outerWidth();
                $(button).closest("table").find("th.resource-url").css("width", width);
                $upload_error.show();
                isUploadingUrl = false;
              }
            });
          } else {
            $.ajax({
              url: "/api/3/action/resource_create",
              dataType: 'json',
              data: JSON.stringify(resource_data),
              cache: false,
              type: "POST",
              success: function (data) {
                $(button).removeAttr('disabled');
                // New entry does not have a field change listner - this sets it up
                CKAN.Dgu.changeOfRowData($(button).closest("tr"));
                $(button).hide();
                $(button).closest("tr").find(".resource-id").find("input").val(data.result.id);
                isUploadingUrl = false;
                $(button).siblings("span.upload-success").text(
                    "Datoteka je bila uspešno shranjena. Ta sprememba ne zahteva ponovnega potrjevanja, " +
                    "zato lahko urejanje zaključite s pritiskom na gumb 'Nazaj na zbirko'.");
                // to prevent jumping content
                var width = $(button).closest("table").find("th.resource-url").outerWidth();
                $(button).closest("table").find("th.resource-url").css("width", width);
                $(button).siblings("span.upload-success").show();
                setTimeout(function () {
                  $(button).siblings("span.upload-success").css('opacity', '0');
                  setTimeout(function () {
                    $(button).siblings("span.upload-success").hide();
                  }, 3000);
                }, 10000);
              },
              error: function (xhr) {
                $(button).removeAttr('disabled');
                // New entry does not have a field change listner - this sets it up
                CKAN.Dgu.changeOfRowData($(button).closest("tr"));
                var $upload_error = $(button).siblings("span.upload-error");
                // to prevent jumping content
                var width = $(button).closest("table").find("th.resource-url").outerWidth();
                $(button).closest("table").find("th.resource-url").css("width", width);
                $upload_error.text("Napaka " + xhr.status + " pri shranjevanju povezave: " + xhr.responseJSON.error.message);
                $upload_error.addClass('error');
                $upload_error.show();
                isUploadingUrl = false;
              }
            });
          }
        } else {
          $(button).removeAttr('disabled');
        }
        jQuery(document).foundation('equalizer', 'reflow');
      });
    };

    my.triggerFileInput = function (uploadButton) {
      //trigger file browser
      var $fileInput = $($('#fileForm').children('input:file')[0]);
      //change event handling of the file input to this button
      $fileInput.off();
      $fileInput.click(function (e) {
        e.stopPropagation();
      });
      $fileInput.change(function () {
        //get all input fields
        CKAN.Dgu.fileInputChange(uploadButton);
      });
      //reset any other chosen upload row, but not if this one is chosen
      if (!$(uploadButton).hasClass('btn-upload-chosen')) {
        var $chosenFields = $(".btn-upload-chosen");
        CKAN.Dgu.initForUpload($chosenFields.closest("tr"));
        $fileInput.click(); //do we need this?
      }
    };

    my.fileInputChange = function (uploadButton) {
      var $fileInput = $($('#fileForm').children('input:file')[0]);
      var reupload = $(uploadButton).hasClass('reupload');
      var $formatInput = $(uploadButton).closest("td").siblings(".resource-format").find("input");
      var $descriptionInput = $(uploadButton).closest("td").siblings(".resource-description").find("input");
      var $dateInput = $(uploadButton).closest("td").siblings(".resource-date").find("input");

      if (reupload) {
        CKAN.Dgu.setUploadResultHandler(uploadButton);
        //on reupload, we just collect the input fields (previous ones should be ok) and trigger immediately
        var fileName = $(uploadButton).siblings("span").find("input").val();
        var description = $descriptionInput.val();
        var format = $formatInput.val();
        var date = $dateInput.length === 0 ? "" : $dateInput.val();
        var refreshInterval = $('#pogostost_osvezevanja').children(":selected").val();
        CKAN.Dgu.submitFileUpload(uploadButton, fileName, description, format, date, refreshInterval);
      } else {
        //on initial upload, we need to show the url input text field, set default values for input fields,
        //change button visibility and additionally confirm the start of upload (after inputting all fields)

        //set this button as chosen for upload and clear handlers
        $(uploadButton).text("Shrani");
        $(uploadButton).addClass("error"); //change to red so it is not overlooked
        $(uploadButton).blur(); //so button is not focused and style correctly changes
        $(uploadButton).addClass("btn-upload-chosen");
        $(uploadButton).off();
        jQuery(document).foundation('equalizer', 'reflow');

        //collect the filename from file input and clean it if needed
        //double all backslashes, so they are not treated as escape chars
        var cleanFilename = $fileInput.val().replace(String.fromCharCode(92), String.fromCharCode(92, 92));
        //clean filename input (Chrome generates c:\fakepath, IE leaves sensitive information)
        cleanFilename = cleanFilename.replace(/^.*[\/\\]/g, "");
        //set filename input field
        $(uploadButton).siblings('span').find('input:text').each(function (index, element) {
          $(element).val(cleanFilename);
        });

        //show url input field and hide url button
        $(uploadButton).siblings(".btn-init-url").hide();
        var $urlInput = $(uploadButton).siblings("span").find("input");
        $urlInput.show();

        //set guessed format and input default description
        var fileNameSplit = cleanFilename.split(".");
        if (fileNameSplit.length > 1 && (fileNameSplit[0] != "" || fileNameSplit.length > 2)) {
          $formatInput.val(fileNameSplit.pop());
        }
        $descriptionInput.val(fileNameSplit.join("."));

        //set new handler to button for submitting form
        $(uploadButton).click(function (e) {
          e.stopPropagation();
          var noResource = true;
          // allow saving resources if no resources of other type are saved
          $('#timeseries_resources-table, #individual_resources-table').find('tr .resource-id').each(function (index, e) {
            if ($(this).find('input').val()) {
              noResource = false;
            }
          });
          //check that the resource to upload is the same type as the currently saved ones
          var isSameType = noResource || storedResourceType === "any" || $(uploadButton).closest('tr').hasClass(storedResourceType);
          if (!isSameType) {
            $(uploadButton).siblings("span.upload-error").text("Po menjavi tipa vnosa (enkraten/periodičen) mora biti zbirka pred shranjevanjem datotek ponovno shranjena.");
            $(uploadButton).siblings("span.upload-error").addClass('error');
            // to prevent jumping content
            var width = $(uploadButton).closest("table").find("th.resource-url").outerWidth();
            $(uploadButton).closest("table").find("th.resource-url").css("width", width);
            $(uploadButton).siblings("span.upload-error").show();
            jQuery(document).foundation('equalizer', 'reflow');
            return;
          }

          CKAN.Dgu.setUploadResultHandler(uploadButton);
          var fileName = $(uploadButton).siblings("span").find("input").val();
          var description = $descriptionInput.val();
          var format = $formatInput.val();
          var date = $dateInput.length === 0 ? "" : $dateInput.val();
          var refreshInterval = $('#pogostost_osvezevanja').children(":selected").val();
          CKAN.Dgu.submitFileUpload(uploadButton, fileName, description, format, date, refreshInterval);
        });
      }
    };

    my.initUploadButton = function (uploadButton) {
      $(uploadButton).off(); //clear all event handlers
      var reupload = $(uploadButton).hasClass('reupload');
      if (reupload)
        $(uploadButton).text("Naloži novo"); //set text for reupload
      else
        $(uploadButton).text("Naloži"); //set text for first upload
      $(uploadButton).removeClass('error'); //set text for first upload
      $(uploadButton).blur(); //set text for first upload

      $(uploadButton).click(function (e) {
        e.stopPropagation();
        //upload only possible when dataset is already saved (we check if we are editing)
        var isDatasetSaved = jQuery('div.icon.edit').length > 0;
        var ownerOrg = jQuery("#owner_org").hasClass('saved');
        var isUploading = $('#fileForm').hasClass('uploading');
        var noResource = true;
        // allow saving resources if no resources of other type are saved
        $('#timeseries_resources-table, #individual_resources-table').find('tr .resource-id').each(function (index, e) {
          if ($(this).find('input').val()) {
            noResource = false;
          }
        });

        //check that the resource to upload is the same type as the currently saved ones
        var isSameType = noResource || storedResourceType === "any" || $(uploadButton).closest('tr').hasClass(storedResourceType);

        if (!isDatasetSaved || !ownerOrg) {
          //show message
          $(uploadButton).siblings("span.upload-error").text("Za prenos datotek mora biti zbirka najprej shranjena, lahko tudi le kot osnutek z izbrano organizacijo.");
          $(uploadButton).siblings("span.upload-error").addClass('error');
          // to prevent jumping content
          var width = $(uploadButton).closest("table").find("th.resource-url").outerWidth();
          $(uploadButton).closest("table").find("th.resource-url").css("width", width);
          $(uploadButton).siblings("span.upload-error").show();
          jQuery(document).foundation('equalizer', 'reflow');
        }

        if (isUploading) {
          $(uploadButton).siblings("span.upload-error").text("Naenkrat lahko poteka le en prenos.");
          $(uploadButton).siblings("span.upload-error").addClass('error');
          // to prevent jumping content
          var width = $(uploadButton).closest("table").find("th.resource-url").outerWidth();
          $(uploadButton).closest("table").find("th.resource-url").css("width", width);
          $(uploadButton).siblings("span.upload-error").show();
          jQuery(document).foundation('equalizer', 'reflow');
        }

        if (!isSameType) {
          $(uploadButton).siblings("span.upload-error").text("Po menjavi tipa vnosa (enkraten/periodičen) mora biti zbirka pred nalaganjem datotek ponovno shranjena.");
          $(uploadButton).siblings("span.upload-error").addClass('error');
          // to prevent jumping content
          var width = $(uploadButton).closest("table").find("th.resource-url").outerWidth();
          $(uploadButton).closest("table").find("th.resource-url").css("width", width);
          $(uploadButton).siblings("span.upload-error").show();
          jQuery(document).foundation('equalizer', 'reflow');
        }

        if (isDatasetSaved && ownerOrg && !isUploading && isSameType) {
          CKAN.Dgu.triggerFileInput(uploadButton);
        }
      });
    }

    my.initForUpload = function (row) {
      $(row).find(".resource-format").find("input").val("");
      $(row).find(".resource-description").find("input").val("");
      $(row).find(".resource-url").find("input").val("");
      var uploadButton = $(row).find(".btn-init-upload");
      var urlButton = $(row).find(".btn-init-url");
      uploadButton.off();
      urlButton.off();
      uploadButton.show();
      urlButton.show()
      uploadButton.removeClass("btn-upload-chosen reupload");
      CKAN.Dgu.initUploadButton(uploadButton);
      CKAN.Dgu.initUrlButton(urlButton);
      $(row).find(".validate-resource-button").hide();
      $(row).find(".resource-url input").hide();
    };

    my.copyTableRowOnClick = function (button, table, initUpload) {
      initUpload = typeof initUpload !== 'undefined' ? initUpload : false;
      button.attr('onclick', '').click(function () {
        var newRow = CKAN.Dgu.addTableRow(table);
        if (initUpload) {
          CKAN.Dgu.initForUpload(newRow);
        }
      });
    };

    //Attach package autocompletion to provided elements
    my.setupPackageAutocomplete = function (elements) {
      elements
          // don't navigate away from the field on tab when selecting an item
          .bind("keydown", function (event) {
            if (event.keyCode === $.ui.keyCode.TAB &&
                $(this).data("autocomplete").menu.active) {
              event.preventDefault();
            }
          })
          .autocomplete({
            minLength: 1,
            source: function (request, callback) {
              // here request.term is whole list of packages so need to get last
              var _realTerm = $.trim(request.term.split(',').pop());
              var url = CKAN.SITE_URL + '/api/2/util/dataset/autocomplete?incomplete=' + _realTerm;
              $.getJSON(url, function (data) {
                // data = { ResultSet: { Result: [ {Name: tag} ] } } (Why oh why?)
                var packages = $.map(data.ResultSet.Result, function (value, idx) {
                  return {value: value.name, label: value.title}
                });
                callback(
                    $.ui.autocomplete.filter(packages, _realTerm)
                );
              });
            },
            focus: function () {
              // prevent value inserted on focus
              return false;
            },
            select: function (event, ui) {
              var terms = this.value.split(',');
              // remove the current input
              terms.pop();
              // add the selected item
              terms.push(terms.length == 0 ? ui.item.value : " " + ui.item.value);
              this.value = terms.join(",");
              return false;
            }
          });
    };

    my.setupTagAutocomplete = function (elements) {
      elements
          // don't navigate away from the field on tab when selecting an item
          .bind("keydown", function (event) {
            if (event.keyCode === $.ui.keyCode.TAB &&
                $(this).data("autocomplete").menu.active) {
              event.preventDefault();
            }
          })
          .autocomplete({
            minLength: 1,
            source: function (request, callback) {
              // here request.term is whole list of tags so need to get last
              var _realTerm = $.trim(request.term.split(',').pop());
              var url = CKAN.SITE_URL + '/api/util/tag/autocomplete_all?incomplete=' + _realTerm;
              $.getJSON(url, function (data) {
                // data = { ResultSet: { Result: [ {Name: tag} ] } } (Why oh why?)
                var tags = $.map(data.ResultSet.Result, function (value, idx) {
                  return value.Name.includes(',') && !value.Name.startsWith('"') && !value.Name.endsWith('"') ? '"' + value.Name + '"' : value.Name;
                });
                callback(
                    $.ui.autocomplete.filter(tags, _realTerm)
                );
              });
            },
            focus: function () {
              // prevent value inserted on focus
              return false;
            },
            select: function (event, ui) {
              var terms = this.value.split(',');
              // remove the current input
              terms.pop();
              // add the selected item
              terms.push(" " + ui.item.value);
              // add placeholder to get the comma-and-space at the end
              terms.push(" ");
              this.value = terms.join(",");
              return false;
            }
          });
    };

    my.setupUserAutocomplete = function (elements) {
      elements.autocomplete({
        minLength: 2,
        source: function (request, callback) {
          var url = '/api/2/util/user/autocomplete?q=' + request.term;
          $.getJSON(url, function (data) {
            $.each(data, function (idx, userobj) {
              var label = '';
              userobj.name;
              if (userobj.fullname) {
                label += userobj.fullname;
              }
              label += ' [' + userobj.name + ']';
              userobj.label = label;
              userobj.value = userobj.id;
            });
            callback(data);
          });
        },
        select: function (event, ui) {
          var $input_box = $(this);
          $input_box.val(ui.item.label);
          $input_box.siblings('.chosen-user').val(ui.item.id);
          //update also contact details
          var user_url = '/api/3/action/user_show?id=' + ui.item.id;
          $.getJSON(user_url, function (data) {
            var result = data.hasOwnProperty('result')
            if (result) {
              if (data.result.hasOwnProperty('email')) {
                $('#foi-email').val(data.result.email);
                $('#foi-email-dialog').val(data.result.email);
                $('#foi-email-label').text(data.result.email);
              }
              if (data.result.hasOwnProperty('fullname')) {
                $('#foi-name').val(data.result.fullname);
                $('#foi-name-dialog').val(data.result.fullname);
                $('#foi-name-label').text(data.result.fullname);
              } else if (data.result.hasOwnProperty('display_name')) {
                $('#foi-name').val(data.result.display_name);
                $('#foi-name-dialog').val(data.result.display_name);
                $('#foi-name-label').text(data.result.display_name);
              }
            }
          });
          return false; // to cancel the event ;)
        }
      });
    };

    my.bindResourceMoveButtons = function (button) {
      button.bind('click', function (e) {
        e.preventDefault();
        var target = $(e.delegateTarget);
        var table = target.closest('table');
        var rows = table.find('tr');
        var index = table.find('tr').index(target.closest('tr'));
        // Should be going either up or down
        var up = target.hasClass('resource-move-up');
        var down = target.hasClass('resource-move-down');
        assert((up && !down) || (!up && down), 'up XOR down should be true: ' + up + ',' + down);
        // Function to exchange the <INPUT> values between two rows
        // Trust me, this is simpler than trying to manipulate the table
        function swapValues(tr1, tr2) {
          assert(tr1.length);
          var input1 = tr1.find('input[type="text"]');
          var input2 = tr2.find('input[type="text"]');
          assert(input1.length > 0, 'Found no inputs to swap', tr1);
          for (var i = 0; i < input1.length; i++) {
            var a = $(input1[i]);
            var b = $(input2[i]);
            var swap = a.val();
            a.val(b.val());
            b.val(swap);
          }

          // Copy all elements inside tr1.hidden-resource-fields to tr1.hidden_resource-fields
          // we know there is at least one hidden field, the id and we should get them so we know
          // what we are swapping
          var hidden1 = tr1.find('.hidden-resource-fields')
          var id1 = hidden1.find('input[type="hidden"]').get(0)
          id1 = $(id1).attr('name').match(/__\d+__/gi)[0]

          var hidden2 = tr2.find('.hidden-resource-fields')
          var id2 = hidden2.find('input[type="hidden"]').get(0)
          id2 = $(id2).attr('name').match(/__\d+__/gi)[0]

          // Swap the HTML over from one TD to the other.
          var swap = hidden2.html()
          hidden2.html(hidden1.html())
          hidden1.html(swap)

          var firstReplacer = new RegExp(id2, 'g')
          var secondReplacer = new RegExp(id1, 'g')

          hidden1.find('input[type="hidden"]').each(function () {
            // Replace the old ID we copied across with the new ID for this container
            var new_id = $(this).attr('name').replace(firstReplacer, id1)
            $(this).attr('id', new_id)
            $(this).attr('name', new_id)
          })

          hidden2.find('input[type="hidden"]').each(function () {
            // Replace the old ID we copied across with the new ID for this container
            var new_id = $(this).attr('name').replace(secondReplacer, id2)
            $(this).attr('id', new_id)
            $(this).attr('name', new_id)
          })
        }

        if (up) {
          assert(index > 1, 'First up button should be disabled');
          assert(index < rows.length - 1, 'Last up button should be disabled');
          // Array splice upwards
          swapValues($(rows[index]), $(rows[index - 1]));
        }
        if (down) {
          assert(index < rows.length - 2, 'Last down button should be disabled');
          // Array splice downwards
          swapValues($(rows[index]), $(rows[index + 1]));
        }
        CKAN.Dgu.setVisibleResourceMoveButtons(table);
        return false;
      });
    };

    my.bindResourceRemoveButton = function (button) {
      function cancelChange(e) {
        e.preventDefault();
        $('#delete_resource_modal .ok').off('click');
        $('#delete_resource_modal .cancel').off('click');
        $('#delete_resource_modal').foundation('reveal', 'close');
      }

      function clearUploadAjax() {
      }

      function deleteResourceAjax(res_id, row, $resource_td_error) {
        $.ajax({
          url: "/api/3/action/resource_delete",
          dataType: 'json',
          data: '{"id": "' + res_id + '"}',
          cache: false,
          type: "POST",
          success: function (response) {
            //delete the row itself
            row.remove();
            isDeletingResource = false;
          },
          error: function (xhr, options, error_message) {
            try {
              var parsedMessage = $.parseJSON(xhr.responseText);
              if (parsedMessage.error && xhr.responseJSON.error.message === "Not Found Error") {
                row.remove();
              } else {
                $resource_td_error.text("Napaka " + xhr.status + " pri brisanju datoteke: " + xhr.responseJSON.error.message);
                button.prop('disabled', false);
              }
            } catch (e) {
              $resource_td_error.text("Napaka " + xhr.status + " pri brisanju datoteke: " + xhr.responseJSON.error.message);
              button.prop('disabled', false);
            }
            isDeletingResource = false;
          }
        });
      }

      function deleteResource(e) {
        e.preventDefault(e);
        $('#delete_resource_modal .ok').off('click');
        $('#delete_resource_modal .cancel').off('click');
        var row = button.closest('tr');
        var res_id = row.find(".resource-id > input").val();
        var res_url = row.find("td.resource-url").val();
        if (!res_url)
          res_url = "fake_url";
        if (res_id) {
          //delete resource, first we need to remove upload if it is present
          button.prop('disabled', true);
          row.find("td.resource-url").find("span.upload-success").hide();
          var $resource_td_error = row.find("td.resource-url").find("span.upload-error");
          $resource_td_error.text("Datoteka se briše, prosimo počakajte na izbris vrstice.");
          $resource_td_error.addClass('error');
          // to prevent jumping content
          var width = row.closest("table").find("th.resource-url").outerWidth();
          row.closest("table").find("th.resource-url").css("width", width);
          $resource_td_error.show();
          isDeletingResource = true;
          var isUploaded = row.find('.resource-url-type > input').val() == 'upload';
          if (isUploaded) {   //we must call resource_update with clear_upload first to delete file
            $.ajax({
              url: "/api/3/action/resource_update",
              dataType: 'json',
              data: '{"id": "' + res_id + '", "url": "' + res_url + '", "clear_upload": true, "pogostost_osvezevanja": "neredno"}',
              cache: false,
              type: "POST",
              success: function (response) {
                deleteResourceAjax(res_id, row, $resource_td_error);
              },
              error: function (xhr, options, error_message) {
                isDeletingResource = false;
                $resource_td_error.text("Napaka " + xhr.status + " pri odstranjevanju naložene datoteke: " + xhr.responseJSON.error.message);
                button.prop('disabled', false);
              }
            });
          } else {
            deleteResourceAjax(res_id, row, $resource_td_error);
          }
        } else {
          //just remove the row, resource wasn't saved yet
          row.remove();
        }
        $('#delete_resource_modal').foundation('reveal', 'close');
      }

      $(button).bind('click', function (e) {
        e.preventDefault();
        var row = button.closest('tr');
        var res_id = row.find(".resource-id > input").val();
        if (res_id) {
          $('#delete_resource_modal').foundation('reveal', 'open');
          $('#delete_resource_modal .cancel').click(cancelChange);
          $('#delete_resource_modal .ok').click(deleteResource);
        } else { // confirmation is not needed
          //just remove the row, resource wasn't saved yet
          row.remove();
        }
      });
    };

    my.setVisibleResourceMoveButtons = function (table) {
      /* Update the visibility of resource-move buttons.
       * In simple terms: The final two buttons are invisible.
       * Of the visible ones, the first "Up" and last "Down" buttons are disabled.  */
      var all = table.find('.resource-move');
      $.each(all, function (i, element) {
        element = $(element);
        disabled = (i == 0 || i >= all.length - 3);
        element.attr('disabled', disabled);
        visible = (i >= all.length - 2) ? 'none' : 'inline-block';
        element.css('display', visible);
      });
    };

    /**
     * Setup the given button to validate the given resource URLs.
     *
     * button - the button that when pressed triggers the validation
     * getResources - a callable that returns the <tr> resources to validate
     **/
    my.validateResource = function (button, getResources) {
      $(button).click(function () {
        $(this).attr({'disabled': 'disabled'});
        $(this).siblings('span.checking-links-label').show();
        var resources = getResources();
        var urlResourceValues = $(resources).map(function () {
          return $(this).find('input[name$="__url"]').val();
        });

        var deferreds = [];
        for (var i = 0; i < urlResourceValues.length; i++) {
          deferreds.push($.ajax({
            url: CKAN.SITE_URL + '/qa/link_checker',
            traditional: true,
            context: resources[i],
            data: {url: urlResourceValues[i]},
            dataType: 'json',
            success: function (data) {
              var formatField = $(this).find('input[id$="__format"]');
              var fmt = data[0].format

              // Populate the format field (if it isn't "htm" or "html")
              //if($.trim(formatField.val()) == "" && !fmt.match(/^html?$/) ){
              formatField.val(data[0].format);
              //}
              // Indicate any url errors
              if (data[0].url_errors.length) {
                // If an empty url field, then only display error if there's at least one
                // other non-empty field in that row.
                var requiredFields = ["url", "description", "format", "date"];
                var showError = false;
                for (var j = 0; j < requiredFields.length; j++) {
                  var field = $(this).find('input[id$="__' + requiredFields[j] + '"]');
                  showError = field.length > 0 && $.trim(field.val()) !== '';
                  if (showError) {
                    break;
                  }
                }
                if (showError) {
                  var width = $(button).closest("table").find("th.resource-url").outerWidth();
                  $(button).closest("table").find("th.resource-url").css("width", width); // to prevent jumping content
                  $(button).siblings("span.upload-error").text(data[0].url_errors[0]).addClass('error').show();
                } else {
                  $(button).siblings("span.upload-error").hide();
                }
              } else {
                $(button).siblings("span.upload-error").hide();
              }
            },
            timeout: 10000
          }));
        }

        $.when.apply($, deferreds).then(function () {
          $(button).removeAttr('disabled');
          $(button).siblings('span.checking-links-label').hide();
        });

        /*
         // MK: Below can work instead of above multiple ajax calls, but if requests are made through
         // a proxy (e.g. Drupal hook_menu), it must support duplicate query parameters (multiple 'url').
        var urls = []; // copy url values in order that data serialises correctly in
                       // the ajax request.  I don't know why it doesn't work otherwise.
        for(var i=0; i<urlResourceValues.length; i++) { urls.push(urlResourceValues[i]); }
        $.ajax({
          url: CKAN.SITE_URL + '/qa/link_checker',
          traditional: true,
          context: resources,
          data: { url: urls },
          dataType: 'json',
          success: function(data){
            for(var i=0; i<data.length; i++){
              var formatField = $(this[i]).find('input[id$="__format"]');
              var fmt = data[i].format

              // Populate the format field (if it isn't "htm" or "html")
              //if($.trim(formatField.val()) == "" && !fmt.match(/^html?$/) ){
              formatField.val(data[i].format);
              //}

              // Indicate any url errors
              if(data[i].url_errors.length) {
                // If an empty url field, then only display error if there's at least one
                // other non-empty field in that row.
                var requiredFields = ["url", "description", "format", "date"];
                var showError = false;
                for(var j=0; j<requiredFields.length; j++){
                  var field = $(this[i]).find('input[id$="__'+requiredFields[j]+'"]');
                  showError = field.length >0 && $.trim(field.val()) !== '';
                  if(showError){break;}
                }
                if(showError){
                  $(this[i]).find('input[id$="__url"]').parent().addClass('error').attr({'title': data[i].url_errors[0]});
                } else {
                  $(this[i]).find('input[id$="__url"]').parent().removeClass('error').removeAttr('title');
                }
              } else {
                $(this[i]).find('input[id$="__url"]').parent().removeClass('error').removeAttr('title');
              }
            }
          },
          complete: function(){
            $(button).removeAttr('disabled');
            $(button).siblings('span.checking-links-label').hide();
          },
          timeout: 10000
        });*/
        return false;
      });
    };

    /** Checks cookie for already liked packages and increases number of likes if not in the cookie */
    $('#dataset-like').click(function () {
      var id = this.dataset.id;
      var cookie = $.cookie('package_likes');
      var inCookie = false;
      if (cookie) {
        var cookies = cookie.split(',');
        if (!($.inArray(id.toString(), cookies) < 0)) {
          inCookie = true;
        }
      }

      if (!inCookie) {
        $.ajax({
          type: 'GET',
          url: '/dataset/increase_likes/' + id,
          success: function (data) {
            if (!cookie) {
              $.cookie('package_likes', id, {expires: 10000});
            } else {
              cookie += ',' + id;
              $.cookie('package_likes', cookie, {expires: 10000});
            }
            var count = $('.like_count span').text();
            $('.like_count span').text(parseInt(count, 10) + 1);
          }
        });
      }
    });
  });
  return my;
}(jQuery, CKAN.Dgu || {});

jQuery(function ($) {
  CKAN.Dgu.UrlEditor = (function () {
    function UrlEditor(_options) {
      // Function bindings
      this.titleToSlug = __bind(this.titleToSlug, this);
      this.titleChanged = __bind(this.titleChanged, this);
      this.urlChanged = __bind(this.urlChanged, this);
      this.checkSlugIsValid = __bind(this.checkSlugIsValid, this);
      this.apiCallback = __bind(this.apiCallback, this);
      this.disable = __bind(this.disable, this);
      // Initial state
      this.updateTimer = null;
      this.titleInput = $('.js-title');
      this.urlInput = $('.js-url-input');
      this.validMsg = $('.js-url-is-valid');
      this.lengthMsg = $('.url-is-long');
      this.lastTitle = "";
      this.disableTitleChanged = false;
      // Settings
      this.regexToChar = [[new RegExp('\u010C', 'g'), 'C'], [new RegExp('\u010D', 'g'), 'c'],
        [new RegExp('\u0160', 'g'), 'S'], [new RegExp('\u0161', 'g'), 's'],
        [new RegExp('\u017D', 'g'), 'Z'], [new RegExp('\u017E', 'g'), 'z'],
        [new RegExp('\u0106', 'g'), 'C'], [new RegExp('\u0107', 'g'), 'c'],
        [new RegExp('\u0110', 'g'), 'DZ'], [new RegExp('\u0111', 'g'), 'dz']];
      this.regexToHyphen = [new RegExp('[ .:/_]', 'g'),
        new RegExp('[^a-zA-Z0-9-_]', 'g'),
        new RegExp('-+', 'g')];
      this.regexToDelete = [new RegExp('^-*', 'g'),
        new RegExp('-*$', 'g')];
      // Default options
      this.options = {
        apiUrl: CKAN.SITE_URL + '/api/2/util/is_slug_valid',
        MAX_SLUG_LENGTH: 100,
      };
      $.extend(this.options, _options);
      // Grab page state
      this.originalUrl = this.urlInput.val();
      // Hook up event handlers
      this.titleInput.keyup(this.titleChanged);
      this.titleInput.keydown(this.titleChanged);
      this.titleInput.keypress(this.titleChanged);
      this.titleInput.change(this.titleChanged);
      this.urlInput.keyup(this.urlChanged);
      this.urlInput.keydown(this.urlChanged);
      this.urlInput.keypress(this.urlChanged);
      this.urlInput.change(this.urlChanged);
      this.urlInput.keyup(this.disable);
      this.urlInput.keydown(this.disable);
      this.urlInput.keypress(this.disable);
      // Set up the form
      this.urlChanged();
    };

    // If you've bothered typing a URL, I won't overwrite you
    UrlEditor.prototype.disable = function () {
      this.disableTitleChanged = true;
    };

    // Guess a nice slug given the title
    UrlEditor.prototype.titleToSlug = function (title) {
      var slug = title;
      $.each(this.regexToChar, function (idx, regex) {
        slug = slug.replace(regex[0], regex[1]);
      });
      $.each(this.regexToHyphen, function (idx, regex) {
        slug = slug.replace(regex, '-');
      });
      $.each(this.regexToDelete, function (idx, regex) {
        slug = slug.replace(regex, '');
      });
      slug = slug.toLowerCase();

      if (slug.length > this.options.MAX_SLUG_LENGTH) {
        slug = slug.substring(0, this.options.MAX_SLUG_LENGTH);
      }
      return slug;
    };

    // Called when the title changes
    UrlEditor.prototype.titleChanged = function () {
      if (this.disableTitleChanged) {
        return;
      }
      var title = this.titleInput.val();
      if (title == this.lastTitle) {
        return;
      }
      this.lastTitle = title;
      slug = this.titleToSlug(title);
      this.urlInput.val(slug);
      this.urlInput.change();
    };

    // Called when the url is changed
    UrlEditor.prototype.urlChanged = function () {
      var slug = this.urlInput.val();
      if (slug == this.lastSlug) {
        return;
      }
      this.lastSlug = slug;
      if (this.updateTimer) {
        clearTimeout(this.updateTimer);
      }
      if (slug.length < 2) {
        this.validMsg.html('<span style="font-weight: bold; color: #444;">Naslov URL je prekratek.</span>');
      } else if (slug == this.originalUrl) {
        this.validMsg.html('<span style="font-weight: bold; color: #000;">To je trenutni naslov URL.</span>');
      } else {
        this.validMsg.html('<span style="color: #777;">Preverjanje...</span>');
        var self = this;
        this.updateTimer = setTimeout(function () {
          self.checkSlugIsValid(slug);
        }, 200);
      }
      if (slug.length > 20) {
        this.lengthMsg.show();
      } else {
        this.lengthMsg.hide();
      }
    };

    // Ask the server whether we can create this dataset URL
    UrlEditor.prototype.checkSlugIsValid = function (slug) {
      $.ajax({
        url: this.options.apiUrl,
        data: 'type=' + this.options.slugType + '&slug=' + slug,
        dataType: 'jsonp',
        type: 'get',
        jsonpCallback: 'callback',
        success: this.apiCallback
      });
    };

    /* Called when the slug-validator gets back to us */
    UrlEditor.prototype.apiCallback = function (data) {
      if (data.valid) {
        this.validMsg.html('<span style="font-weight: bold; color: #0c0">Ta naslov URL še ni zaseden.</span>');
      } else {
        this.validMsg.html('<span style="font-weight: bold; color: #c00">Na žalost je ta naslov URL že zaseden.</span>');
      }
    };

    return UrlEditor;
  })();
});


